package pLF4_HexBinCalc;

/****************************************************************************************************
 * 
 * 
 *
 * @author Sven Marceta
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class BinaryCalculater
{
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private static final String REGEX_BIN = "[0-1]{1,}";
	private String oparateor;
	private String binaryInput;
	private int result = 0;
	Model model;
	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public BinaryCalculater(Model aModel)
	{
		model = aModel;
		
		setBinaryInput("0");
		setOparateor("");
		setResult(0);
	}

	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	

	
	public void solve()
	{
		int inputDez = Integer.parseInt(binaryInput, 2);
		
		switch (oparateor)
		{
		case "+": result = result + inputDez; break;
		case "*":result = result * inputDez; break;
		case "-":result = result - inputDez; break;
		case "/":result = result / inputDez; break;
		default:
			
			result = inputDez;
		}
		
		setOparateor("");
		setBinaryInput("0");
		setResult(result);
	}

	public void setOperation(String aNewOperation)
	{
		switch (aNewOperation)
		{
		case "*", "-", "/", "+":
			solve();
			setOparateor(aNewOperation);
			break;
		case "=":
			solve();
			break;
		}
		
		//oparateor = "";
		//binaryInput = "0";
		
		//view.SetOperator(oparateor);
		//view.setResult(result);
	}
	

	public void addNumber(String aNumber)
	{
		setBinaryInput(binaryInput + aNumber);
	}
	
	// -------------------------------------------------------------------------------------
	// GETTER / SETTER 
	/**
	 * @param aOparateor the oparateor to set
	 */
	public void setOparateor(String aOparateor)
	{
		oparateor = aOparateor;
		
		if (model != null)
			model.getAusgabe().SetOperator(oparateor);
	}
	/**
	 * @param aBinaryInput the binaryInput to set
	 */
	public void setBinaryInput(String aBinaryInput)
	{
		if(aBinaryInput == null)
			throw new NullPointerException("Binary number could be null");
		
		if(aBinaryInput.matches(REGEX_BIN))
			binaryInput = aBinaryInput;
		
		if (model != null)
			model.getAusgabe().setBinInput(binaryInput);
	}
	/**
	 * @param aResult the result to set
	 */
	public void setResult(int aResult)
	{
		result = aResult;
		
		if (model != null)
			model.getAusgabe().setResult(result);
	}


	// -------- Ende der Klasse 
}
