package ue650_Taschenrechner;

import java.awt.BorderLayout;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;

import ue010_ErsterDialog.EingabeDialog;

import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import java.awt.Color;
import javax.swing.JButton;
import java.awt.GridBagLayout;
import javax.swing.BoxLayout;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.SwingConstants;
import java.awt.SystemColor;

/****************************************************************************************************
 * 
 * Baut einen Tashcenrechenr dar Geteilt, Mal, Minus und Plus
 * rechnen kann.
 * Weiter soll es auch möglich sein ein Komma zu benützen
 * 
 * Hinzugefögte Operationen sind ^2, Wurzel und das Speicher einer Zahl auf A
 *
 * @author Sven Marceta
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class _Main_Taschenrechner extends JFrame
{
	
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private JPanel contentPane;
	private JTextField txtZwisch;
	private JTextField txtEingabe;
	private JTextField txtSymbole;
	
	String memoryText = ""; //Text der schreiben der eingabe ist
	double equalsTo = 0; // am ende Ausgerechnete Zahl
	double savedA = 0; // Die Varable a auf die Werte gespeichert werden aknn
	
	/**
	 * Launch the application.
	 */
	public static void main(String[] args)
	{
		EventQueue.invokeLater(new Runnable()
		{
			public void run()
			{
				try
				{
					_Main_Taschenrechner frame = new _Main_Taschenrechner();
					frame.setVisible(true);
				} catch (Exception e)
				{
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public _Main_Taschenrechner()
	{
		/**
		 * Alle werte für den Fram einstellen
		 */
		setTitle("Rechner");
		setResizable(false);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 231, 434);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		contentPane.setLayout(new BorderLayout(0, 0));
		setContentPane(contentPane);
		
		/**
		 * Erstellt und setzt einen JPanel
		 */
		JPanel panel = new JPanel();
		contentPane.add(panel, BorderLayout.CENTER); //Panel wird in die Mitte geset
		panel.setLayout(null);// Absulutes Layout
		
		//-----------------------------------------------------------------------------------------------
		//Einfache Zahlen und Kommar
		
		/**
		 * Button für den Komma
		 */
		JButton btnComma = new JButton(".");
		/**
		 * Wenn der Button gedrückt wird, soll er bei eingabe erscheinen
		 */
		btnComma.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				NumberToEINGABE(btnComma.getText());
			}
		});
		btnComma.setBackground(new Color(0, 128, 128));
		btnComma.setBounds(0, 339, 51, 50);
		panel.add(btnComma);
		
		/**
		 * Button für die Zahl 0
		 */
		JButton btn0 = new JButton("0");
		/**
		 * Wenn der Button gedrückt wird, soll er bei eingabe erscheinen
		 */
		btn0.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				NumberToEINGABE(btn0.getText());
			}
		});
		btn0.setBackground(new Color(0, 255, 255));
		btn0.setBounds(51, 339, 51, 50);
		panel.add(btn0);
		
		/**
		 * Button für die Zahl 1
		 */
		JButton btn1 = new JButton("1");
		/**
		 * Wenn der Button gedrückt wird, soll er bei eingabe erscheinen
		 */
		btn1.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				NumberToEINGABE(btn1.getText());
			}
		});
		btn1.setBackground(new Color(0, 255, 255));
		btn1.setBounds(0, 287, 51, 50);
		panel.add(btn1);
		
		/**
		 * Button für die Zahl 2
		 */
		JButton btn2 = new JButton("2");
		/**
		 * Wenn der Button gedrückt wird, soll er bei eingabe erscheinen
		 */
		btn2.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				NumberToEINGABE(btn2.getText());
			}
		});
		btn2.setBackground(new Color(0, 255, 255));
		btn2.setBounds(51, 287, 51, 50);
		panel.add(btn2);
		
		/**
		 * Button für die Zahl 3
		 */
		JButton btn3 = new JButton("3");
		/**
		 * Wenn der Button gedrückt wird, soll er bei eingabe erscheinen
		 */
		btn3.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				NumberToEINGABE(btn3.getText());
			}
		});
		btn3.setBackground(new Color(0, 255, 255));
		btn3.setBounds(101, 287, 51, 50);
		panel.add(btn3);
		
		/**
		 * Button für die Zahl 4
		 */
		JButton btn4 = new JButton("4");
		/**
		 * Wenn der Button gedrückt wird, soll er bei eingabe erscheinen
		 */
		btn4.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				NumberToEINGABE(btn4.getText());
			}
		});
		btn4.setBackground(new Color(0, 255, 255));
		btn4.setBounds(0, 237, 51, 50);
		panel.add(btn4);
		
		/**
		 * Button für die Zahl 5
		 */
		JButton btn5 = new JButton("5");
		/**
		 * Wenn der Button gedrückt wird, soll er bei eingabe erscheinen
		 */
		btn5.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				NumberToEINGABE(btn5.getText());
			}
		});
		btn5.setBackground(new Color(0, 255, 255));
		btn5.setBounds(51, 237, 51, 50);
		panel.add(btn5);
		
		/**
		 * Button für die Zahl 6
		 */
		JButton btn6 = new JButton("6");
		/**
		 * Wenn der Button gedrückt wird, soll er bei eingabe erscheinen
		 */
		btn6.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				NumberToEINGABE(btn6.getText());
			}
		});
		btn6.setBackground(new Color(0, 255, 255));
		btn6.setBounds(101, 237, 51, 50);
		panel.add(btn6);
		
		/**
		 * Button für die Zahl 7
		 */
		JButton btn7 = new JButton("7");
		/**
		 * Wenn der Button gedrückt wird, soll er bei eingabe erscheinen
		 */
		btn7.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				NumberToEINGABE(btn7.getText());
			}
		});
		btn7.setBackground(new Color(0, 255, 255));
		btn7.setBounds(0, 187, 51, 50);
		panel.add(btn7);
		
		/**
		 * Button für die Zahl 8
		 */
		JButton btn8 = new JButton("8");
		/**
		 * Wenn der Button gedrückt wird, soll er bei eingabe erscheinen
		 */
		btn8.setBackground(new Color(0, 255, 255));
		btn8.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				NumberToEINGABE(btn8.getText());
			}
		});
		btn8.setBounds(51, 187, 51, 50);
		panel.add(btn8);
		
		/**
		 * Button für die Zahl 9
		 */
		JButton btn9 = new JButton("9");
		/**
		 * Wenn der Button gedrückt wird, soll er bei eingabe erscheinen
		 */
		btn9.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				NumberToEINGABE(btn9.getText());
			}
		});
		btn9.setBackground(new Color(0, 255, 255));
		btn9.setBounds(101, 187, 51, 50);
		panel.add(btn9);
		
		//-----------------------------------------------------------------------------------------------
		//Operationen
		
		/**
		 * Button für den Plus
		 */
		JButton btnPlus = new JButton("+");
		/**
		 * Wenn der Button gedrückt wird, soll eine rechnung durchgeführt werden
		 * Wenn keine da ist wird er einfach nur gesetzt
		 * Der txtxSymbol wird auch gesetzt
		 */
		btnPlus.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				simpelOperation(btnPlus.getText());
			}
		});
		btnPlus.setBackground(Color.RED);
		btnPlus.setBounds(156, 339, 51, 50);
		panel.add(btnPlus);
		
		JButton btnMinus = new JButton("-");
		/**
		 * Wenn der Button gedrückt wird, soll eine rechnung durchgeführt werden
		 * Wenn keine da ist wird er einfach nur gesetzt
		 * Der txtxSymbol wird auch gesetzt
		 */
		btnMinus.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				simpelOperation(btnMinus.getText());
			}
		});
		btnMinus.setBackground(Color.RED);
		btnMinus.setBounds(156, 287, 51, 50);
		panel.add(btnMinus);
		
		JButton btnTimes = new JButton("*");
		/**
		 * Wenn der Button gedrückt wird, soll eine rechnung durchgeführt werden
		 * Wenn keine da ist wird er einfach nur gesetzt
		 * Der txtxSymbol wird auch gesetzt
		 */
		btnTimes.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				simpelOperation(btnTimes.getText());
			}
		});
		btnTimes.setBackground(Color.RED);
		btnTimes.setBounds(156, 237, 51, 50);
		panel.add(btnTimes);
		
		JButton btnDivide = new JButton("/");
		/**
		 * Wenn der Button gedrückt wird, soll eine rechnung durchgeführt werden
		 * Wenn keine da ist wird er einfach nur gesetzt
		 * Der txtxSymbol wird auch gesetzt
		 */
		btnDivide.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				simpelOperation(btnDivide.getText());
			}
		});
		btnDivide.setBackground(Color.RED);
		btnDivide.setBounds(156, 187, 51, 50);
		panel.add(btnDivide);
		
		//-----------------------------------------------------------------------------------------------
		//Speicher A und Paste A
				
		/**
		* Fügt den Speicher als A Button hinzu
		* Das ZwischneErgebnis wird als A gespeichert
		*/
		JButton btnStoreA = new JButton("SA");
		btnStoreA.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				savedA = equalsTo;//Das zwischenErgebnis ist als A gespeichert
				
				//Debbungin
				System.out.printf("Variable A = %f \n", savedA);
			}
		});
		btnStoreA.setHorizontalAlignment(SwingConstants.LEFT);
		btnStoreA.setBackground(SystemColor.activeCaption);
		btnStoreA.setBounds(0, 138, 51, 50);
		panel.add(btnStoreA);
			
		/**
		 * Fügt den Paste A Button hinzu
		 * Der Gespeicherte Wert als A kann in rechnung verwended werden
		 * Er kann nur alleine Verwended werden
		 */
		JButton btnRemember = new JButton("PA");
		btnRemember.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				txtEingabe.setText("A");//Set den Text von der eingabe auf "A"
				memoryText = String.valueOf(savedA); // Der gespeicherte Wert von a wird zum Text gesetzt
			}
		});
		btnRemember.setBackground(SystemColor.activeCaption);
		btnRemember.setBounds(51, 138, 51, 50);
		panel.add(btnRemember);

		//-----------------------------------------------------------------------------------------------
		//Beended rechnung Operationen

		/**
		 * Fügt den ist-Glaich Buton hinzu
		 * Nach dem Ist-Gleich wird kann nicht mehr weiter gerechnet werden
		 */
		JButton btnSoulution = new JButton("=");
		btnSoulution.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				//Da "=" Nicht teil der simpel Operationen sind wird die nächste rechnung einfah übernommen
				simpelOperation(btnSoulution.getText()); 
			}
		});
		btnSoulution.setBackground(SystemColor.activeCaption);
		btnSoulution.setBounds(101, 339, 51, 50);
		panel.add(btnSoulution);
		
		/**
		 * Fügt den Hoch 2 Buttton hinzu
		 * Danach kann nicht mehr Wietergerechnet werden
		 * Erhöht das ergebnis mit mit dem ergebnis selbst
		 */
		JButton btnSquere = new JButton("^2");
		btnSquere.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				//Da "^2" Nicht teil der simpel Operationen sind wird die nächste rechnung einfach übernommen
				simpelOperation(btnSquere.getText()); 
				equalsTo *= equalsTo; // Ergebnis wird mit sich selbst Multiplieziert
				txtZwisch.setText(String.valueOf(equalsTo));//Text setzen
			}
		});
		btnSquere.setBackground(SystemColor.activeCaption);
		btnSquere.setBounds(156, 138, 51, 50);
		panel.add(btnSquere);
		
		/**
		 * Fügt den Wurzel Ziehen Buttton hinzu
		 * Danach kann nicht mehr Wietergerechnet werden
		 * Zieht die Wurzel für das ergebnis
		 */
		JButton btnRoot = new JButton("√");
		btnRoot.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				//Da "√" Nicht teil der simpel Operationen sind wird die nächste rechnung einfach übernommen
				simpelOperation(btnRoot.getText()); 
				equalsTo = Math.sqrt(equalsTo); // Wurzel ziehen
				txtZwisch.setText(String.valueOf(equalsTo));//Text setzen
			}
		});
		btnRoot.setBackground(SystemColor.activeCaption);
		btnRoot.setBounds(101, 138, 51, 50);
		panel.add(btnRoot);
		
		/**
		 * Fügt den Clear Button hinzu
		 * Setzt alle werte auf 0 und alle Texte auf ""
		 * "A" wird nicht zurückgesetzt
		 */
		JButton btnCLR = new JButton("CLR");
		btnCLR.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				ClearMemmory();//Löscht MemoryText und Eingabe
				
				//Rest Clear
				equalsTo = 0;
				txtZwisch.setText("");
				txtSymbole.setText("");
			}
		});
		btnCLR.setBackground(new Color(128, 0, 0));
		btnCLR.setBounds(0, 114, 78, 23);
		panel.add(btnCLR);
		
		//-----------------------------------------------------------------------------------------------
		//Ausgabe und Label
		
		/**
		 * Ein Label für den zwischen Ergebnis wird erstelt und gesetzt
		 */
		JLabel lblZwischenEergebnis = new JLabel("ZwischenErgebnis");
		lblZwischenEergebnis.setHorizontalAlignment(SwingConstants.TRAILING);
		lblZwischenEergebnis.setBounds(0, 31, 46, 14);
		panel.add(lblZwischenEergebnis);
		
		/**
		 * Ein JTextField wird erstellt und gesetzt
		 * 
		 * es dient zum ergebnis der Rechnung zum zeigen
		 */
		txtZwisch = new JTextField();
		txtZwisch.setHorizontalAlignment(SwingConstants.RIGHT); // Die zahlen sollen rechts stehen
		txtZwisch.setForeground(new Color(0, 255, 0));
		txtZwisch.setBackground(new Color(128, 128, 128));
		txtZwisch.setEditable(false); //in diesem text soll man selber nichts reinschreiben dürfen
		txtZwisch.setBounds(51, 22, 135, 32);
		panel.add(txtZwisch);
		txtZwisch.setColumns(10);
		
		/**
		 * Ein JLabel wird erstellt und gesetzt
		 */
		JLabel lblEingabe = new JLabel("Eingabe");
		lblEingabe.setBounds(0, 77, 46, 14);
		panel.add(lblEingabe);
		
		/**
		 * Ein JTextField wird erstellt und gesetzt
		 * 
		 * es dient zum zeigen der eingabe nach jedem Button press
		 */
		txtEingabe = new JTextField();
		txtEingabe.setHorizontalAlignment(SwingConstants.RIGHT);//Zahlen sollen rechts stehen
		txtEingabe.setEditable(false); //Man darf es nicht selber editiren
		txtEingabe.setBackground(new Color(128, 128, 128));
		txtEingabe.setForeground(new Color(0, 255, 0));
		txtEingabe.setBounds(51, 66, 156, 37);
		panel.add(txtEingabe);
		txtEingabe.setColumns(10);
		
		/**
		 * Symbole text
		 * Wird verwended um zu wissen welche Operation durchgeführt weden muss
		 */
		txtSymbole = new JTextField();
		txtSymbole.setHorizontalAlignment(SwingConstants.CENTER);
		txtSymbole.setEditable(false);
		txtSymbole.setForeground(new Color(0, 0, 0));
		txtSymbole.setBackground(new Color(255, 99, 71));
		txtSymbole.setBounds(186, 22, 18, 32);
		panel.add(txtSymbole);
		txtSymbole.setColumns(10);
		txtSymbole.setText(" "); //Wird Leer gesetzt um erste überprufung zu durchführen
	}
	
	/**
	 * Diese Methode fügt die gedrückte Zahl in den memoryText an, der dann in Eingabe ausgeschrieben wird
	 *
	 * @param numberBtn
	 * 			numberBtn, ist die Zahl die gedrückt wurde
	 */
	public void NumberToEINGABE(String textNumber)
	{
		memoryText += textNumber; //Den Text per Zahl ausgegeben
		
		//Debbuging
		System.out.printf("%s \n", memoryText);
		
		txtEingabe.setText(memoryText); //Text ausgeben
	}
	
	/**
	 * In dieser Methode wird der Wer der zwischenErgebnis mit dem wert der eingabe gerechnet
	 * Wie gerechnet wird häng von der Operation aus, hier sind des nur die simplen +,-,* und /
	 * Das ergebnis wird gerunded und als zwischenEergebnis gespeichert
	 * Memorytext wird auf 0 gesetzt
	 *
	 * @param textOperation
	 * 			Ist die Operation die beim drücken der übertragen wird
	 * 			Sie wird dann auf txtSymbole gesetzt um später zu rechnen
	 */
	public void simpelOperation(String textOperation)
	{
		double newNumb = 0;//Zuerst iniatilisiert
		
		//Überprüft ob die eingabe eine gültige Zahl ist und Speichert sie
		try
		{
			newNumb = Double.parseDouble(memoryText);// der text wird als double gespeichert
			
			//Debbunging
			System.out.printf("%f \n", newNumb);
		} catch (NumberFormatException e) // Wenn nicht, dann ein Error
		{
			//Pop up
			//Eine neue Frame wird erstellt, dann Die nachricht, Titel, und letztleich was für eine art von Massage
			JOptionPane.showMessageDialog(new JFrame(), "Ungültige Zahl", "Error", JOptionPane.ERROR_MESSAGE);
		}
		
		//debbunging
		System.out.printf("%s \n", txtSymbole.getText());
		
		/**
		 * Je nach Operation wird anders gerechnet
		 * 
		 * Math.Raound Runded auf die nächstlegende zahl
		 * Da wir nur die zweite kommastelle runden wollen, müssen wir zuerst Mal 100 rechnen
		 * Dann noch geteilt durch 100 um die originalzahl wirderzubekommen
		 */
		switch(txtSymbole.getText()) {
		case "+":
			//Debbuging
			System.out.printf("Plus \n", BOTTOM_ALIGNMENT);
			
			//Ausrechnen und zum Zwischenergebnis setzten
			equalsTo += newNumb;
			equalsTo = Math.round(equalsTo * 100.0) / 100.0; //Auf 2 comastellen runden
			txtZwisch.setText(String.valueOf(equalsTo));
			
			//Eingabe leeren
			ClearMemmory();
			
			//Zum symbol setzen
			txtSymbole.setText(textOperation);
			
			break;
		case "-":
			//Debbuging
			System.out.printf("Minus \n", BOTTOM_ALIGNMENT);
			
			//Ausrechnen und zum Zwischenergebnis setzten
			equalsTo  -= newNumb;
			equalsTo = Math.round(equalsTo * 100.0) / 100.0; //Auf 2 comastellen runden
			txtZwisch.setText(String.valueOf(equalsTo));
			
			//Eingabe leeren
			ClearMemmory();
			
			//Zum symbol setzen
			txtSymbole.setText(textOperation);
			
			break;
		case "*":
			//Debbuging
			System.out.printf("Mal \n", BOTTOM_ALIGNMENT);
			
			//Ausrechnen und zum Zwischenergebnis setzten
			equalsTo = equalsTo * newNumb;
			equalsTo = Math.round(equalsTo * 100.0) / 100.0;
			txtZwisch.setText(String.valueOf(equalsTo));
			
			//Eingabe leeren
			ClearMemmory();
			
			//Zum symbol setzen
			txtSymbole.setText(textOperation);
			
			break;
		case "/":
			//Debbuging
			System.out.printf("Geteilt \n", BOTTOM_ALIGNMENT);
			
			//Ausrechnen und zum Zwischenergebnis setzten
			equalsTo = equalsTo / newNumb;
			equalsTo = Math.round(equalsTo * 100.0) / 100.0; //Auf 2 comastellen runden
			txtZwisch.setText(String.valueOf(equalsTo));
			
			//Eingabe leeren
			ClearMemmory();
			
			//Zum symbol setzen
			txtSymbole.setText(textOperation);
			
			break;
		default: //Wenn es noch kein Operation  gibt, oder ien rechnung ist zuende ,wird nur gesetzt
			
			equalsTo = newNumb;
			txtZwisch.setText(String.valueOf(equalsTo));
			
			//Eingabe leeren
			ClearMemmory();
			
			//Zum symbpl setzen
			txtSymbole.setText(textOperation);
			
			break;
		}
	}
	
	/**
	 * Leert nur die Eingabe und den memeoryText
	 * wird gebraucht nachdem gerechnet wurde
	 */
	public void ClearMemmory()
	{
		//Eingabe leeren
		memoryText = "";
		txtEingabe.setText("");
	}
	
}
