package ue810_UserDb.controller;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;

/****************************************************************************************************
 * 
 *
 * @author Sven Marceta
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class DbController
{
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private String dbUrl;
	private Connection dbConnection;
	private Tbl_User tbl_user;

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public DbController(String aUrl)
	{
		if(aUrl == null)
			throw new NullPointerException("Url darf nicht null sin!");
		if(aUrl.isEmpty())
			throw new IllegalArgumentException("Url darf nicht leer sin!");
		dbUrl = aUrl;
	}

	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	public void connect() throws SQLException {
		dbConnection = DriverManager.getConnection(dbUrl);
		
		tbl_user = new Tbl_User(this);
		
		System.out.printf("Datenbank erfolgreich verbunden: %s \n",
				dbConnection.getMetaData().getDatabaseProductName());
	}

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER 
	/**
	 * @return the dbConnection
	 */
	public Connection getDbConnection()
	{
		return dbConnection;
	}
	
	/**
	 * @return the tbl_user
	 */
	public Tbl_User getTbl_user()
	{
		return tbl_user;
	}

	// -------------------------------------------------------------------------------------
	// TOSTRING



	// -------- Ende der Klasse 
}
