package pUe391_ADObjekte;

/****************************************************************************************************
 * 
 * TODO Die Überklasse
 *
 * @author Sven MArceta
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class AD_Object
{
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private String name;
	private String beschreibung;

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public AD_Object(String aName, String aBeschreibung)
	{
		//Im setter wird nach NUll und isEmpty geprüft
		setName(aName);
		setBeschreibung(aBeschreibung);
	}

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER 
	/**
	 * @return the name
	 */
	public String getName()
	{
		return name;
	}

	/**
	 * @return the beschreibung
	 */
	public String getBeschreibung()
	{
		return beschreibung;
	}

	/**
	 * @param Prüft NUll und isEmpty, sonst setzt beschreibung
	 */
	public void setName(String aName)
	{
		if(aName == null)
			throw new NullPointerException("Der Name darf nicht null sein!");
		if(aName.isEmpty())
			throw new IllegalArgumentException("Der Name darf nicht leer sein!");
		
		name = aName;
	}

	/**
	 * @param Prüft NUll und isEmpty, sonst setzt beschreibung
	 */
	public void setBeschreibung(String aBeschreibung)
	{
		if(aBeschreibung == null)
			throw new NullPointerException("Die Beschreibung darf nicht null sein!");
		if(aBeschreibung.isEmpty())
			throw new IllegalArgumentException("Die Beschreibung darf nicht leer sein!");
		
		beschreibung = aBeschreibung;
	}

	// -------------------------------------------------------------------------------------
	// TOSTRING
	@Override
	public String toString()
	{
		return String.format("AD_Object [name=%s, beschreibung=%s]", name, beschreibung);
	}


	// -------- Ende der Klasse 
}
