package pUe391_ADObjekte;

/****************************************************************************************************
 * 
 * TODO Benutzer
 *
 * @author Sven MArceta
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class Benutzer extends AD_Object implements _ILogin
{
	
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private final static String REGEX_EMAIL = "^\\w+[\\w-\\.]*\\@\\w+((-\\w+)|(\\w*))\\.[a-z]{2,3}$";
	private final static String REGEX_PASSWORT = "((?=.*\\d)(?=.*[a-z])(?=.*[A-Z])(?=.*[@#$%]).{6,20})";
	
	private String passwort;
	private String email;
	private BenutzerGruppe gruppe;

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public Benutzer(String aName, String aBeschreibung, BenutzerGruppe aGruppe)
	{
		super(aName, aBeschreibung);
		
		if(aGruppe == null)//Überptüft aob NULL
			throw new NullPointerException("Die Gruppe darf nicht null sein!");
		
		//Alles okay, wird gesetzt
		gruppe = aGruppe;
	}	

	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	/**
	 * @return True oder False
	 */
	@Override
	public boolean checkPasswort(String aPasswortToCheck)
	{
		return aPasswortToCheck.equals(passwort);
	}
	/**
	 *	@param aPasswort was überpruft wird
	 *  @return  Gibt True oder false zurück
	 */
	public static boolean isValidPasswort(String aPasswort)
	{
		if(aPasswort == null)//Überprüft ob passwort null ist
			throw new NullPointerException("Das Passwort darfd nicht null sein!");
		
		return aPasswort.matches(REGEX_PASSWORT); // Gibt tur oder False aus, wenn es der REGEX Übereinstimmt
	}
	/**
	 * @param aEmail, die email dieÜberprüft wird
	 * @return  Gibt True oder false zurück
	 */
	public static boolean isValidEMail(String aEmail)
	{
		if(aEmail == null)//Überprüft ob passwort null ist
			throw new NullPointerException("Die Email darfd nicht null sein!");
		if(aEmail.isEmpty())//Überprüft ob die Email leer ist
			throw new IllegalArgumentException("Die Email darf nicht leer sein!");
		
		return aEmail.matches(REGEX_EMAIL); // Gibt True oder False aus, wenn es der REGEX Übereinstimmt
	}

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER
	/**
	 * @return die Email
	 */
	@Override
	public String getEMail()
	{
		return email;
	}
	/**
	 * @param aEmail the email to set
	 */
	public void setEMail(String aEmail)
	{
		if(!isValidEMail(aEmail))
			throw new IllegalArgumentException("Ungültige Email!");

		email = aEmail;
	}
	/**
	 * @param aPasswort the passwort to set
	 */
	public void setPasswort(String aPasswort)
	{
		if(!isValidPasswort(aPasswort))
			throw new IllegalArgumentException("Ungültiges Passwort");
		
		passwort = aPasswort;
	}
	
	// -------------------------------------------------------------------------------------
	// TOSTRING
	@Override
	public String toString()
	{
		return String.format("Benutzer [passwort=%s, email=%s, gruppe=%s, toString()=%s]", passwort, email, gruppe,
				super.toString());
	}
	

	// -------- Ende der Klasse 
}
