package pUe391_ADObjekte;

/****************************************************************************************************
 * 
 * TODO erstellt eine OrganisationalUnit
 *
 * @author Sven MArceta
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class OrganisationalUnit extends AD_Object
{
	
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private boolean deletAble;
	private Domain domain;

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public OrganisationalUnit(String aName, String aBeschreibung, Domain aDomain)
	{
		super(aName, aBeschreibung); //Benützt di superklasse zum setzen
		
		if(aDomain == null) //Überprüft auf NULL
			throw new NullPointerException("die Domain darf nicht Null sein!");
		
		//Alles okay, wird gesetzt
		domain = aDomain;
		deletAble = true;
	}
	
	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	/**
	 * @return the deletAble
	 */
	public boolean isDeleteAble()
	{
		return deletAble;
	}

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER 
	/**
	 * Setzt das Deletable
	 * 
	 * @param aDeletAble the deletAble to set
	 */
	public void setDeleteAble(boolean aDeletAble)
	{
		deletAble = aDeletAble;
	}
	
	/**
	 * @return the domain
	 */
	public Domain getDomain()
	{
		return domain;
	}

	// -------------------------------------------------------------------------------------
	// TOSTRING
	@Override
	public String toString()
	{
		return String.format("OrganisationalUnit [deletAble=%s, domain=%s, toString()=%s]", deletAble, domain,
				super.toString());
	}

	// -------- Ende der Klasse 
}
