package pUe391_ADObjekte;

import java.util.ArrayList;
import java.util.List;

/****************************************************************************************************
 * 
 * TODO Die Main
 *
 * @author Sven Marceta
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class _Main_ADObjekte
{
	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	/**
	 *
	 * @param args
	 * file = dei Datai die iengelesen wird
	 * lines = die zeilen die vom Input gelesen werde
	 * domain ist die Domain
	 * organisationalUnits ist eine Liste von organisationalUnits
	 * benutzerGruppes ist eine Liste von BenutzerGruppen
	 * BenutzerListe ist eine Liste von Benutzer
	 * invalidEmalilcnt ist eine INT die +1 gerevhnet wird wenn eine Emil ungültig ist
	 */
	public static void main(String[] args)
	{
		//List alles von der Input file
		Textfile file = new Textfile("src/pUe391_ADObjekte/");
		List<String> lines = file.read("Input.txt");
		
		//Initializierung
		Domain domain = null;
		List<OrganisationalUnit> organisationalUnits = new ArrayList<>();
		List<BenutzerGruppe> benutzerGruppes = new ArrayList<>();
		List<Benutzer> benutzerListe = new ArrayList<>();
		int invalidEmalilcnt = 0;
		
		//Domain erstellen
		for(String line : lines) // Geht jede Line einzeln duch
		{
			String[] teil = line.split(",");
			if(teil[0].equals("D")) // Der erste Teil gibt an ob es eine Domain, Organ., BenutzerGr. oder Benutzer ist
			{
				domain = new Domain(teil[1], teil[2]);
				break;
			}
		}
		
		//BenutzerGruppen und OrganisationalUnits erstellen
		for(String line : lines)
		{
			String[] teil = line.split(",");
			
			if (teil[0].equals("O")) // O = OrganisationalUntits
			{
				organisationalUnits.add(new OrganisationalUnit(teil[1], teil[2], domain));
			}
			else if (teil[0].equals("G")) // G = BenutzerGr.
			{
				benutzerGruppes.add(new BenutzerGruppe(teil[1], teil[2], domain));
			}
		}
		
		//Benutzer erstellen
		for(String line : lines)
		{
			String[] teil = line.split(",");
			if(teil[0].equals("B")) // B = Benutzer
			{
				BenutzerGruppe gruppe = null; //eine Leere Benutzergruppe erstellen
				for(BenutzerGruppe grup : benutzerGruppes) //Geht jede Benutzergruppe durch
				{
					if(grup.getName().equals(teil[3])) //Teil[3] gibt die Gruppe des Benutzers an
					{
						gruppe = grup; // Wenn eine Benutzergruppe mit dem des Nutzer Übereinstimmt wird die gruppe dort gepointet
						break;
					}
				}
				
				if(gruppe != null) // überprüft ob nicht null
				{
					benutzerListe.add(new Benutzer(teil[1], teil[2], gruppe)); // wennn es vorher gefunen wurde ist es nicht null, und wird zum benutzer hinzugefugt
				}
			}
		}
		
		//Setzten von EMail adressen und zählen von Falschen
		for(String line : lines)
		{
			String[] teil = line.split(",");
			if(teil[0].equals("E")) // E = Email
			{
				for(Benutzer benutzer : benutzerListe) // Geht alle benutzer durch
				{
					if(benutzer.getName().equals(teil[1]))// Teil[1] steht ein Name, wenn mit eines Benutzer übereinstimmt wird weiter gearbeitet
					{
						if(Benutzer.isValidEMail(teil[2])) //Teil[2] steht eine Email, die wird überprüft
						{
							benutzer.setEMail(teil[2]); //der benutzter bekommt die Email
						}
						else
							invalidEmalilcnt++; //Es wird gezehlt wie viele Invalid email es gibt
						break;
					}
				}
			}
		}
		
		//Ausgabe der Benutzer
		for(Benutzer benutzer : benutzerListe)
		{
			System.out.printf(benutzer + "\n");
		}
		
		//Ausgabe von ungültigen EMail Adressen
		System.out.printf(" \n Anzahl der ungültigenEMail Adressen %d \n", invalidEmalilcnt);
	}

	// -------- Ende der Klasse 
}
