package ue018_BMW;

import sew.G2D;

/****************************************************************************************************
 * 
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class BMW
{
	// -------------------------------------------------------------------------------------
	// INSTANZVARIABLEN
	private String	typ;			// nicht null und nicht leer
	private char	bauart;			// 'S' -> Sport, 'K' -> Kombi,  'C' -> Coupe
	private String	farbe;			// nicht null und nicht leer
	private int 	leistung;		// 0 -600PS

	private String picture;
	
	
	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR
	public BMW(String aTyp, String aFarbe, char aBauart, int aLeistung)
	{
		// Überprüfung von aTyp ob es nicht null ist oder leer-String
		if(aTyp == null)
			throw new NullPointerException("Typ darf nich null sein");
		if(aTyp.equals(""))
			throw new IllegalArgumentException("Typ darf kein leer-String sein");
		
		//Überprüfung von Bauart da es nur 'S','K' oder 'C' Sein darf
		aBauart = Character.toUpperCase(aBauart); // Auf Großschreibeung setzten
		if(aBauart != 'S' && aBauart != 'K' && aBauart != 'C')
			throw new IllegalArgumentException("Bauart muss L, K oder C Sein!");
		

		//Überprüfung  und setzen mit setter
		setFarbe(aFarbe);
		setLeistung(aLeistung);
		
		//Alle Überprüfungen bestanden!
		typ = aTyp;
		bauart = aBauart;
	}

	/**
	 * TODO 
	 *
	 */
	public void paint() 
	{
		if (picture != null)
			G2D.drawImage(picture, 100, 100, this);
	}
	
	
	// -------------------------------------------------------------------------------------
	// GETTER / SETTER 
	public String getTyp()
	{
		return typ;
	}
	public char getBauart()
	{
		return bauart;
	}
	public int getLeistung()
	{
		return leistung;
	}
	public String getFarbe()
	{
		return farbe;
	}

	/**
	 * TODO Setzt neune wert für leistung ein
	 *
	 * @param aLeistung		Neuer wert 
	 */
	public void setLeistung(int aLeistung)
	{
		//Überprüfung dass Leistung zwischen 0 und 600 PS ist
		if(aLeistung <= 0 || aLeistung > 600)
			throw new IllegalArgumentException("Leistung darf nurr zwischen 0 und 600 PS sein");
		leistung = aLeistung;
	}
	public void setFarbe(String aFarbe)
	{
		if(aFarbe == null)
			throw new NullPointerException("Farbe darf nicht null sein");
		if(aFarbe.equals(""))
			throw new IllegalArgumentException("Farbe darf kein Leer-String sein");
		farbe = aFarbe;
	}
	public void setPicture(String aPicture)
	{
		picture = aPicture;
	}
	
	@Override
	public String toString()
	{
		return String.format("BMW [typ=%s, bauart=%s, farbe=%s, leistung=%s]", typ, bauart, farbe, leistung);
	}


	// -------- Ende der Klasse 
}
