package ue100_Fahrzeuge;

/****************************************************************************************************
 * 
 * TODO (lösche TODO und füge hier deinen Kommentar ein!)
 *
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class Auto
{
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private String fin;			// Nicht null/leer
	private String marke;		// Nicht null/leer
	private char treibstoff;	//Nur S(Super) oder D(Diesel)
	private double vAktuell;	//Aktuele geschwindigkeit
	private char bauart;		//C= Cabrio, K=Kombi, L=Limbosine


	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public Auto (String aFIN, String aMarke, char aTreibstoff, char aBauart) {
		if(aFIN == null || aFIN == "")
		{
			throw new IllegalArgumentException("Fahrzeugidentifikationsnummer darf nicht leer sein!");
		}
		fin = aFIN;
		
		if(aMarke == null || aMarke == "")
		{
			throw new IllegalArgumentException("Marke darf nicht leer sein!");
		}
		marke = aMarke;
		
		if(aTreibstoff != 'S' && aTreibstoff != 'D') {
			throw new IllegalArgumentException("Traibstoff ist entweder S oder D");
		}
		treibstoff = aTreibstoff;
		
		if(aBauart != 'C' && aBauart != 'L' && aBauart != 'k') {
			throw new IllegalArgumentException("Keine Gültige Bauart");
		}
		bauart = aBauart;
	}

	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	/**
	 * TODO Beschleudigung des Autos
	 *
	 * @param a		Beschleunigung
	 * @param t		Dauer der Beschleunigung
	 * @return		Geschwindigkeit nacg der Beschleunigung
	 */
	public double beschleunigen(double a, double  t) {
		
		if(a < 0) 
			throw new IllegalArgumentException("Ein Auto kann nicht weniger als 0 beschleunigen!");
		if(t < 0)
			throw new IllegalArgumentException("Dauer muss größer als 0 sein!");
		
		//Alles ist gut
		vAktuell = vAktuell+ a*t; //beusleunigung wird ausgerechnet
		if(vAktuell > 108_000_000.0)
			vAktuell = 108_000_000.0; //maximal Licht-Geschwindichkeit
		return vAktuell;
	}
	/**
	 *  TODO Bremsen des autos
	 *
	 * @param a		Beschleunigung
	 * @param t		Dauer der Bremsung
	 * @return		Geschwindigkeit nacg der Bremsung
	 */
	public double bremsen(double a, double  t)
	{
		if(a < 0)
			throw new IllegalArgumentException("Beschleunigung muss größer als 0 sein!");
		if(t < 0)
			throw new IllegalArgumentException("Dauer muss größer als 0 sein!");
		
		//Alles ist gut
		vAktuell = vAktuell - a * t;
		if(vAktuell < 0) {
			vAktuell = 0.0;
		}
		return vAktuell;
	}

	
	

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER
	//Es gibt keine SETTER!
	/**
	 * @return the fin
	 */
	public String getFin()
	{
		return fin;
	}
	/**
	 * @return the marke
	 */
	public String getMarke()
	{
		return marke;
	}
	/**
	 * @return the treibstoff
	 */
	public char getTreibstoff()
	{
		return treibstoff;
	}
	/**
	 * @return the vAktuell
	 */
	public double getvAktuell()
	{
		return vAktuell;
	}

	// -------------------------------------------------------------------------------------
	// TOSTRING
	@Override
	public String toString()
	{
		return String.format("Auto [fin=%s, marke=%s, treibstoff=%s, vAktuell=%s]",
								fin, marke, treibstoff, vAktuell);
	}



	// -------- Ende der Klasse 
}
