package ue100_Fahrzeuge;

/****************************************************************************************************
 * 
 * TODO (lösche TODO und füge hier deinen Kommentar ein!)
 *
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class Cabrio
{
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private String fin;			// Nicht null/leer
	private String marke;		// Nicht null/leer
	private char treibstoff;	//Nur S(Super) oder D(Diesel)
	private double vAktuell;	//Aktuele geschwindigkeit
	private char bauart;		//C= Cabrio, K=Kombi, L=Limbosine
	private boolean verdeckoffen; //True falls das Verck offen ist

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public Cabrio(String aFin, String aMarke, char aTreibstoff, char aBauart)
	{
		if(aFin == null || aFin == "")
		{
			throw new IllegalArgumentException("Fahrzeugidentifikationsnummer darf nicht leer sein!");
		}
		fin = aFin;
		
		if(aMarke == null || aMarke == "")
		{
			throw new IllegalArgumentException("Marke darf nicht leer sein!");
		}
		marke = aMarke;
		
		if(aTreibstoff != 'S' && aTreibstoff != 'D') {
			throw new IllegalArgumentException("Traibstoff ist entweder S oder D");
		}
		treibstoff = aTreibstoff;
		
		if(aBauart != 'C' && aBauart != 'L' && aBauart != 'k') {
			throw new IllegalArgumentException("Keine Gültige Bauart");
		}
		bauart = aBauart;
	}

	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	/**
	 * TODO Beschleunigung berechnen
	 *
	 * @param a
	 * @param t
	 * @return
	 */
	public double beschleunigen(double a, double  t) {
		vAktuell = vAktuell+ a*t; //beusleunigung wird ausgerechnet
		if(vAktuell < 0) {
			throw new IllegalArgumentException("Ein Auto kann nicht weniger als 0 beschleunigen");
		}
		
		return vAktuell;
	}
	/**
	 *  TODO Bremsen des autos
	 *
	 * @param a
	 * @param t
	 * @return
	 */
	public double bremsen(double a, double  t)
	{
		vAktuell = vAktuell - a * t;
		if(vAktuell < 0) {
			throw new IllegalArgumentException("Ein Auto kann nicht weniger als 0 beschleunigen");
		}
		return vAktuell;
	}
	public boolean isVerdeckoffen()
	{
		if(verdeckoffen != true && verdeckoffen != false) {
			throw new NullPointerException("verdeck offen darf nicht leer sein");
		}
		return verdeckoffen;
	}
	
	// -------------------------------------------------------------------------------------
	// GETTER / SETTER 
	/**
	 * @return the fin
	 */
	public String getFin()
	{
		return fin;
	}
	/**
	 * @return the marke
	 */
	public String getMarke()
	{
		return marke;
	}
	/**
	 * @return the treibstoff
	 */
	public char getTreibstoff()
	{
		return treibstoff;
	}
	/**
	 * @return the vAktuell
	 */
	public double getvAktuell()
	{
		return vAktuell;
	}
	/**
	 * @return the bauart
	 */
	public char getBauart()
	{
		return bauart;
	}
	/**
	 * TODO set Verdeckoffen
	 *
	 * @param aVerdeckoffen
	 */
	public void setVerdeckoffen(boolean aVerdeckoffen)
	{
		verdeckoffen = aVerdeckoffen;
	}

	// -------------------------------------------------------------------------------------
	// TOSTRING
	@Override
	public String toString()
	{
		return String.format("Cabrio [fin=%s, marke=%s, treibstoff=%s, vAktuell=%s, bauart=%s, verdeckoffen=%s]", fin,
				marke, treibstoff, vAktuell, bauart, verdeckoffen);
	}


	// -------- Ende der Klasse 
}
