package ue100_Fahrzeuge;

/****************************************************************************************************
 * 
 * TODO (lösche TODO und füge hier deinen Kommentar ein!)
 *
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class LKW
{
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private String fin;			// Nicht null/leer
	private String marke;		// Nicht null/leer
	private char treibstoff;	//Nur S(Super) oder D(Diesel)
	private double vAktuell;	//Aktuele geschwindigkeit
	private double maxGewicht;	// >= 1000 & <= 50000
	private double aktGewicht;	// von 0 bis maxGewicht
	

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public LKW(String aFin, String aMarke, char aTreibstoff, double aMaxGewicht)
	{
		super();
		if(aFin == null || aFin == "")
		{
			throw new IllegalArgumentException("Fahrzeugidentifikationsnummer darf nicht leer sein!");
		}
		fin = aFin;
		
		if(aMarke == null || aMarke == "")
		{
			throw new IllegalArgumentException("Marke darf nicht leer sein!");
		}
		marke = aMarke;
		
		if(aTreibstoff != 'S' && aTreibstoff != 'D') {
			throw new IllegalArgumentException("Traibstoff ist entweder S oder D");
		}
		treibstoff = aTreibstoff;
		
		if(aMaxGewicht < 1000 || aMaxGewicht > 50000) {
			throw new IllegalArgumentException("Maxgewicht muss zwischen 1000 und 50000 sein");
		}
		maxGewicht = aMaxGewicht;
	}

	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	/**
	 * TODO Beschleudigung des Autos
	 *
	 * @param a
	 * @param t
	 * @return
	 */
	public double beschleunigen(double a, double  t) {
		vAktuell = vAktuell+ a*t; //beusleunigung wird ausgerechnet
		if(vAktuell < 0) {
			throw new IllegalArgumentException("Ein Auto kann nicht weniger als 0 beschleunigen");
		}
		
		return vAktuell;
	}
	/**
	 *  TODO Bremsen des autos
	 *
	 * @param a
	 * @param t
	 * @return
	 */
	public double bremsen(double a, double  t)
	{
		vAktuell = vAktuell - a * t;
		if(vAktuell < 0) {
			throw new IllegalArgumentException("Ein Auto kann nicht weniger als 0 beschleunigen");
		}
		return vAktuell;
	}
	/**
	 * TODO fugt gewicht hinzu und Berechnet das Aktuelle gewicht aus
	 *
	 * @param gewicht
	 * @return
	 */
	public double beladen(double gewicht)
	{
		aktGewicht += gewicht;
		if(aktGewicht < 0 || aktGewicht > maxGewicht) {
			throw new IllegalArgumentException("akt Gewicht ist entweder kleiner als 0 oder zu schwer");
		}
		return aktGewicht;
	}

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER 
	/**
	 * @return the fin
	 */
	public String getFin()
	{
		return fin;
	}
	/**
	 * @return the marke
	 */
	public String getMarke()
	{
		return marke;
	}
	/**
	 * @return the treibstoff
	 */
	public char getTreibstoff()
	{
		return treibstoff;
	}
	/**
	 * @return the vAktuell
	 */
	public double getvAktuell()
	{
		return vAktuell;
	}
	/**
	 * @return the maxGewicht
	 */
	public double getMaxGewicht()
	{
		return maxGewicht;
	}

	// -------------------------------------------------------------------------------------
	// TOSTRING
	@Override
	public String toString()
	{
		return String.format("LKW [fin=%s, marke=%s, treibstoff=%s, vAktuell=%s, maxGewicht=%s, aktGewicht=%s]", fin,
				marke, treibstoff, vAktuell, maxGewicht, aktGewicht);
	}


	// -------- Ende der Klasse 
}
