package ue100_Fahrzeuge;

/****************************************************************************************************
 * 
 * TODO (lösche TODO und füge hier deinen Kommentar ein!)
 *
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class Motorrad
{
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private String fin;			// Nicht null/leer
	private String marke;		// Nicht null/leer
	private char treibstoff;	// Nur S(Super) oder D(Diesel)
	private double vAktuell;	// Aktuele geschwindigkeit
	private double leistung;	// darf nicht leiner als 0 oder größer als 250
	

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public Motorrad(String aFin, String aMarke, char aTreibstoff, double aLeistung)
	{
		if(aFin == null || aFin == "")
		{
			throw new IllegalArgumentException("Fahrzeugidentifikationsnummer darf nicht leer sein!");
		}
		fin = aFin;
		
		if(aMarke == null || aMarke == "")
		{
			throw new IllegalArgumentException("Marke darf nicht leer sein!");
		}
		marke = aMarke;
		
		if(aTreibstoff != 'S' && aTreibstoff != 'D') {
			throw new IllegalArgumentException("Traibstoff ist entweder S oder D");
		}
		treibstoff = aTreibstoff;
		
		if(aTreibstoff < 0 || aTreibstoff > 250) {
			throw new IllegalArgumentException("Leistung darf nicht kleiner als 0 oder gröser als 250 sein");
		}
		leistung   = aLeistung;
	}

	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	/**
	 * TODO Beschleudigung des Autos
	 *
	 * @param a
	 * @param t
	 * @return
	 */
	public double beschleunigen(double a, double  t) {
		vAktuell = vAktuell+ a*t; //beusleunigung wird ausgerechnet
		if(vAktuell < 0) {
			throw new IllegalArgumentException("Ein Auto kann nicht weniger als 0 beschleunigen");
		}
		
		return vAktuell;
	}
	/**
	 *  TODO Bremsen des autos
	 *
	 * @param a
	 * @param t
	 * @return
	 */
	public double bremsen(double a, double  t)
	{
		vAktuell = vAktuell - a * t;
		if(vAktuell < 0) {
			throw new IllegalArgumentException("Ein Auto kann nicht weniger als 0 beschleunigen");
		}
		return vAktuell;
	}

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER 
	/**
	 * @return the fin
	 */
	public String getFin()
	{
		return fin;
	}
	/**
	 * @return the marke
	 */
	public String getMarke()
	{
		return marke;
	}
	/**
	 * @return the treibstoff
	 */
	public char getTreibstoff()
	{
		return treibstoff;
	}
	/**
	 * @return the vAktuell
	 */
	public double getvAktuell()
	{
		return vAktuell;
	}
	/**
	 * @return the leistung
	 */
	public double getLeistung()
	{
		return leistung;
	}

	// -------------------------------------------------------------------------------------
	// TOSTRING
	@Override
	public String toString()
	{
		return String.format("Motorrad [fin=%s, marke=%s, treibstoff=%s, vAktuell=%s, leistung=%s]", fin, marke,
				treibstoff, vAktuell, leistung);
	}


	// -------- Ende der Klasse 
}
