package ue121_Figuren;

import java.awt.Color;

/****************************************************************************************************
 * 
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public interface _IFigur
{

	/** --------------------------------------------------------------------------------<br>
	*  Zeichnet die Figur an der gegebenen Position
	*  Wir wissen jedoch noch nicht welche Figur es wird, deshalb wissen wir auch nicht
	*  wie sie gezeichnet wird! 
	*/
	void paint();

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER
	/** --------------------------------------------------------------------------------<br>
	 * Setzt die Position der Figur
	 *
	 * @param aX
	 * @param aY
	 */
	void setXY(int aX, int aY);

	/** --------------------------------------------------------------------------------<br>
	 * Setzt die x-Koordinate der Figur
	 *
	 * @param aX
	 */
	void setX(int aX);

	int getX();

	/** --------------------------------------------------------------------------------<br>
	 * Setzt die Y-Koordinate der Figur
	 *
	 * @param aY
	 */
	void setY(int aY);

	int getY();

	/** --------------------------------------------------------------------------------<br>
	 * Setzt die Farbe der Figur
	 *
	 * @param aFarbe
	 */
	void setFarbe(Color aFarbe);

	Color getFarbe();

	/** --------------------------------------------------------------------------------<br>
	 * Gibt an, ob die Figur ausgefüllt gezeichnet werden soll
	 *
	 * @param aFill
	 */
	void setFill(boolean aFill);

	boolean isFill();

	// -------------------------------------------------------------------------------------
	String toString();

}