package ue141L_HerrDerRinge;

import java.awt.Image;

import sew.G2D;

/****************************************************************************************************
 * 
 * TODO (lösche TODO und füge hier deinen Kommentar ein!)
 *
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public abstract class Wesen implements _IWesen
{

	
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private String name;
	private int staerke;
	private String waffe;
	private Wesen freundVon;
	private int x;
	private int y;
	private String picture;

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public Wesen(String aName, int aStaerke, String aWaffe)
	{
		if(aName == null)
			throw new NullPointerException("name darf nicht null sein");
		if(aName.equals(""))
			throw new IllegalArgumentException("Name darf nicht leer sein");
		
		//Alles okay!
		name = aName;
		setStaerke(aStaerke);
		setWaffe(aWaffe);
	}


	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	@Override
	public abstract void kaempfen();
	
	@Override
	public abstract void schlafen();
	
	@Override
	public abstract void laufen();

	
	@Override
	public void paint()
	{
		if(picture == null)
			G2D.drawString(name, 400, 400, 100, this);
		else
			G2D.drawImage(picture, 400, 400, this);
	}

	@Override
	public void paint(int aX, int aY)
	{
		setX(aX);
		setY(aY);
		if(picture == null)
			G2D.drawString(name, getX(), getY(), 100, this);
		else if(picture.equals(""))
			G2D.drawString(name, getX(), getY(), 100, this);
		else
			G2D.drawImage(picture, getX(), getY(), this);
	}

	@Override
	public void moveTo(int aX, int aY, int aDelay)
	{
		setX(aX);
		setY(aY);
		G2D.moveTo(getX(), getY(), aDelay, 0.02, this);
	}


	// -------------------------------------------------------------------------------------
	// GETTER / SETTER 
	@Override
	public String getName()
	{
		if(name == null)
			return "null";
		return name;
	}

	@Override
	public int getStaerke()
	{
		return staerke;
	}
	@Override
	public void setStaerke(int aStaerke)
	{
		if(aStaerke <= 0)
			throw new IllegalArgumentException("Staerke darf nicht kleine als 0 sein!");
		staerke = aStaerke;
	}

	@Override
	public String getWaffe()
	{
		return waffe;
	}
	@Override
	public void setWaffe(String aWaffe)
	{
		if(aWaffe == null)
			throw new NullPointerException("Waffe darf nicht null sein");
		if(aWaffe.equals(""))
			throw new IllegalArgumentException("Waffe darf nicht leer sein");
		waffe = aWaffe;
	}

	@Override
	public Wesen getFreundVon()
	{
		return freundVon;
	}
	@Override
	public void setFreundVon(Wesen aFreundVon)
	{
		freundVon = aFreundVon;
	}
	
	@Override
	public void setPicture(String aPicture)
	{
		picture = aPicture;
	}
	
	@Override
	public int getX()
	{
		return x;
	}
	@Override
	public void setX(int aX)
	{
		x = aX;
	}

	@Override
	public int getY()
	{
		return y;
	}
	@Override
	public void setY(int aY)
	{
		y = aY;
	}

	// -------------------------------------------------------------------------------------
	// TOSTRING
	@Override
	public String toString()
	{
		return String.format(" [name=%s, staerke=%s, waffe=%s, FerundVon=%s x=%s, y=%s, picture=%s]", name, staerke, waffe, freundVon.getName(), x,
				y, picture);
	}
	
	// -------- Ende der Klasse 
}
