package ue221_Figurenliste;

import java.awt.Color;

import ue121_Figuren._IFigur;

/****************************************************************************************************
 * 
 * TODO Abstracte methote
 *
 * @author Sven Marceta
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public abstract class Figur implements _IFigur
{
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private int x;
	private int y;
	private Color farbe;
	private boolean fill;


	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public Figur(int aX, int aY, Color aFarbe, boolean aFill)
	{
		//Alles wird mit Setter erstellt
		setX(aX);
		setY(aY);
		setFarbe(aFarbe);
		setFill(aFill);
	}


	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	public abstract void paint();


	// -------------------------------------------------------------------------------------
	// GETTER / SETTER
	/**
	 * retunr x und y
	 */
	public void setXY(int aX, int aY)
	{
		x = aX;
		y = aY;
	}
	
	/**
	 * @param aX the x to set
	 */
	public void setX(int aX)
	{
		x = aX;
	}
	/**
	 * @return the x
	 */
	public int getX()
	{
		return x;
	}
	
	/**
	 * @param aY the y to set
	 */
	public void setY(int aY)
	{
		y = aY;
	}
	/**
	 * @return the y
	 */
	public int getY()
	{
		return y;
	}
	/**
	 * @param aFarbe the farbe to set
	 */
	
	public void setFarbe(Color aFarbe)
	{
		if(aFarbe == null)
			throw new NullPointerException("Farbe darf nicht null sein");
		farbe = aFarbe;
	}
	/**
	 * @return the farbe
	 */
	public Color getFarbe()
	{
		return farbe;
	}

	/** --------------------------------------------------------------------------------<br>
	 * Gibt an, ob die Figur ausgefüllt gezeichnet werden soll
	 *
	 * @param aFill
	 */
	public void setFill(boolean aFill)
	{
		fill = aFill;
	}
	/**
	 * Sagt ob es gefüllt sein soll oder nicht
	 * 
	 * @param isFill
	 */
	public boolean isFill()
	{
		return fill;
	}

	// -------------------------------------------------------------------------------------
	// TOSTRING
	@Override
	public String toString()
	{
		return String.format("[x=%s, y=%s, farbe=%s, fill=%s]", x, y, farbe, fill);
	}
	// -------- Ende der Klasse 
}
