package ue221_Figurenliste;

import java.awt.Color;
import java.util.ArrayList;
import java.util.Random;

import javax.swing.colorchooser.AbstractColorChooserPanel;

/****************************************************************************************************
 * 
 * TODO (lösche TODO und füge hier deinen Kommentar ein!)
 *
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class FigurenListe implements _IFigurenListe
{
	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	private ArrayList<Figur> listeMitFiguren;	//Referenz auf Liste!

	public FigurenListe()
	{
		listeMitFiguren = new ArrayList<>(); // jetzt könne wir die Liste hinzufügen
	}
	
	
	@Override
	public void neueFigurHinzufuegen(Figur aFigur)
	{
		if(aFigur == null)
			throw new NullPointerException("Figur darf nicht null sein!");
		listeMitFiguren.add(aFigur);
	}

	@Override
	public boolean istFigurBereitsInDerListe(Figur aFigur)
	{
		return listeMitFiguren.contains(aFigur);
	}

	@Override
	public void entferneFigurAusDerListe(Figur aFigur)
	{
		listeMitFiguren.remove(aFigur);
	}

	@Override
	public void printFigurenListe()
	{
		for(Figur figur : listeMitFiguren)
		{
			System.out.printf("%s \n", figur.toString());
		}
	}

	@Override
	public void printKreisListe()
	{
		for(Figur figur : listeMitFiguren)
		{
			if(figur instanceof Kreis)
				System.out.printf("%s \n", figur.toString());
		}
	}

	@Override
	public void alleFigurenZeichnen()
	{
		for(Figur figur : listeMitFiguren)
		{
			figur.paint();
		}
	}

	@Override
	public void alleRechteckeZeichnen()
	{
		for(Figur figur : listeMitFiguren)
		{
			if(figur instanceof Rechteck)
				figur.paint();
		}
	}

	@Override
	public void alleQuadrateZeichnen()
	{
		for(Figur figur : listeMitFiguren)
		{
			if(figur instanceof Quadrat)
				figur.paint();
		}
	}

	@Override
	public void alleKreiseZeichnen()
	{
		for(Figur figur : listeMitFiguren)
		{
			if(figur instanceof Kreis)
				figur.paint();
		}
	}

	@Override
	public void alleFigurenAufZufaelligePosition()
	{
		Random random = new Random();
		int upperbound = 800;
		
		for(Figur figur: listeMitFiguren)
		{
			int randX = random.nextInt(upperbound);
			int randY = random.nextInt(upperbound);
			
			figur.setXY(randX, randY);
			
			figur.paint();
		}
	}

	@Override
	public void alleKreiseAufZufaelligePosition()
	{
		Random random = new Random();
		int upperbound = 800;
		
		for(Figur figur: listeMitFiguren)
		{
			if(figur instanceof Kreis)
			{
				int randX = random.nextInt(upperbound);
				int randY = random.nextInt(upperbound);
			
				figur.setXY(randX, randY);
			
				figur.paint();
			}
		}
	}

	@Override
	public void alleRechteckeZufaelligeFaerben()
	{
		Random random = new Random();
		
		
		
		for(Figur figur: listeMitFiguren)
		{
			if(figur instanceof Rechteck)
			{
				float r = random.nextFloat();
				float g = random.nextFloat();
				float b = random.nextFloat();
				
				Color randomColor = new Color(r, g, b);
				figur.setFarbe(randomColor);
			
				figur.paint();
			}
		}
	}

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER

	@Override
	public int getAnzKreis()
	{
		int count = 0;
		for(Figur figur: listeMitFiguren)
		{
			if(figur instanceof Kreis)
				count++;
		}
		
		return count;
	}

	@Override
	public int getAnzRechteck()
	{
		int count = 0;
		for(Figur figur: listeMitFiguren)
		{
			if(figur instanceof Rechteck)
				count++;
		}
		
		return count;
	}

	@Override
	public int getAnzQuadrat()
	{
		int count = 0;
		for(Figur figur: listeMitFiguren)
		{
			if(figur instanceof Quadrat)
				count++;
		}
		
		return count;
	}

	@Override
	public int getAnzRechteckUndQuadrat()
	{
		int count = 0;
		for(Figur figur: listeMitFiguren)
		{
			if(figur instanceof Rechteck || figur instanceof Quadrat)
				count++;
		}
		
		return count;
	}

	@Override
	public int getAnzKreisGroesserAls(int aRadius)
	{
		int count = 0;
		for(Figur figur: listeMitFiguren)
		{
			if(figur instanceof Kreis && ((Kreis) figur).getRadius() > aRadius)
				count++;
		}
		
		return count;
	}

	@Override
	public ArrayList<Rechteck> getRechtecke()
	{
		ArrayList<Rechteck> list = new ArrayList<>();
		
		for(Figur figur: listeMitFiguren)
		{
			if(figur instanceof Rechteck)
				list.add((Rechteck) figur);
		}
		
		return list;
	}

	@Override
	public ArrayList<Quadrat> getQuadrate()
	{
		ArrayList<Quadrat> list = new ArrayList<>();
		
		for(Figur figur: listeMitFiguren)
		{
			if(figur instanceof Quadrat)
				list.add((Quadrat) figur);
		}
		
		return list;
	}

	@Override
	public ArrayList<Kreis> getKreise()
	{
		ArrayList<Kreis> list = new ArrayList<>();
		
		for(Figur figur: listeMitFiguren)
		{
			if(figur instanceof Kreis)
				list.add((Kreis) figur);
		}
		
		return list;
	}

	@Override
	public ArrayList<Quadrat> getQuadrateGroesserAls(int aSeitenlaenge)
	{
		ArrayList<Quadrat> list = new ArrayList<>();
		for(Figur figur: listeMitFiguren)
		{
			if(figur instanceof Quadrat && ((Quadrat) figur).getSeitenlaenge() > aSeitenlaenge)
				list.add((Quadrat) figur);
		}
		
		return list;
	}
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen

	// -------- Ende der Klasse 
}
