package ue221_Figurenliste;

import java.awt.Color;

import sew.G2D;

/****************************************************************************************************
 * 
 * TODO Rechteck erstelen
 *
 * @author Sven Marceta
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class Rechteck extends Figur
{
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private int laenge;
	private int breite;


	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public Rechteck(int aX, int aY, Color aFarbe, boolean aFill, int aLaenge, int aBreite)
	{
		super(aX, aY, aFarbe, aFill);
		
		//Setter werden Benützt
		setLaenge(aLaenge);
		setBreite(aBreite);
	}


	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	@Override
	public void paint()
	{
		if(isFill())
			G2D.fillRect(	getX() - getLaenge(),
							getY() - getBreite(),
							getLaenge(),
							getBreite(), 
							getFarbe(),
							this);
		else
			G2D.drawRect(	getX() - getLaenge(),
							getY() - getBreite(),
							getLaenge(),
							getBreite(), 
							getFarbe(),
							this);
	}

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER
	/**
	 * @return the laenge
	 */
	public int getLaenge()
	{
		return laenge;
	}
	/**
	 * @param aLaenge the laenge to set
	 */
	public void setLaenge(int aLaenge)
	{
		if(aLaenge <= 0)
			throw new IllegalArgumentException("Länge darf nicht kleiner als null sein");
		laenge = aLaenge;
	}
	
	/**
	 * @return the aBreite
	 */
	public int getBreite()
	{
		return breite;
	}
	/**
	 * @param aBreite the breite to set
	 */
	public void setBreite(int aBreite)
	{
		if(aBreite <= 0)
			throw new IllegalArgumentException("Breite darf nicht kleiner als null sein");
		breite = aBreite;
	}

	// -------------------------------------------------------------------------------------
	// TOSTRING
	@Override
	public String toString()
	{
		System.out.print("Rechteck ");
		System.out.print(super.toString());
		return String.format(" [laenge=%s, breite=%s] \n", laenge, breite);
	}
	
	// -------- Ende der Klasse 
}
