package ue231_Zoo;

import java.util.ArrayList;

/****************************************************************************************************
 * 
 * TODO (lösche TODO und füge hier deinen Kommentar ein!)
 *
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class Savanne implements _ISavanne
{
	
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private ArrayList<Wildtier> tiere;

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public Savanne()
	{
		tiere = new ArrayList<Wildtier>();
	}


	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	@Override
	public void neuesTier(Wildtier aTier)
	{
		tiere.add(aTier);
	}

	@Override
	public boolean istTierInDerSavanne(Wildtier aTier)
	{
		return tiere.contains(aTier);
	}

	@Override
	public void tierStirbt(Wildtier aTier)
	{
		tiere.remove(aTier);
	}

	@Override
	public void verlaesstSavanne(Wildtier aTier)
	{
		tiere.remove(aTier);
	}

	@Override
	public void printTierListe()
	{
		for(Wildtier tier : tiere)
		{
			System.out.printf("%s \n", tier.toString());
		}
	}

	@Override
	public void printLoewenListe()
	{
		for(Wildtier tier : tiere)
		{
			if(tier instanceof Loewe)
				System.out.printf("%s \n", tier.toString());
		}
	}

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER
	@Override
	public Loewe getErstenLoewen()
	{
		for(Wildtier tier : tiere)
		{
			if(tier instanceof Loewe)
				return (Loewe) tier;
		}
		return null;
	}

	@Override
	public Gazelle getLetzteGazelle()
	{
		Gazelle temp = null;
		
		for(Wildtier tier : tiere)
		{
			if(tier instanceof Gazelle)
				temp = (Gazelle) tier;
		}
		if(temp == null)
			return null;
		
		return temp;
	}

	@Override
	public Elefant getAeltesterElefant()
	{
		Elefant temp = null;
		
		for(Wildtier tier : tiere)
		{
			if(tier instanceof Elefant)
				temp = (Elefant) tier;
		}
		
		if(temp == null)
			return null;
		
		for(Wildtier tier : tiere)
		{
			if(tier instanceof Elefant)
				if(tier.getAlter() > temp.getAlter())
					temp = (Elefant) tier;
		}
		
		
		return temp;
	}

	@Override
	public Wildtier getJuengstesTier()
	{
		Wildtier temp = tiere.get(0);
		
		if(temp == null)
			return null;
		
		for(Wildtier tier : tiere)
		{
			if(tier.getAlter() < temp.getAlter())
				temp = tier;
		}
		
		
		return temp;
	}

	@Override
	public ArrayList<Wildtier> getTiereEinerArt(String aArt)
	{
		ArrayList<Wildtier> tierEinerArt = new ArrayList<Wildtier>();
		for(Wildtier tier : tiere)
		{
			if(aArt.isEmpty())
				throw new NullPointerException("Art darf nicht NUll sein");
			
			if(tier.getArt().equals(aArt))
				tierEinerArt.add(tier);
		}
		return tierEinerArt;
	}

	@Override
	public ArrayList<Gazelle> gazellenImAlterVon(int aAlter)
	{
		ArrayList<Gazelle> gazellen = new ArrayList<Gazelle>();
		for(Wildtier tier : tiere)
		{
			if(tier.getAlter() == aAlter)
				gazellen.add((Gazelle) tier);
		}
		return gazellen;
	}

	@Override
	public int getAnzLoewen()
	{
		int count = 0;
		for(Wildtier tier : tiere)
		{
			if(tier instanceof Loewe)
				count++;
		}
		return count;
	}

	@Override
	public int getAnzElefanten()
	{
		int count = 0;
		for(Wildtier tier : tiere)
		{
			if(tier instanceof Elefant)
				count++;
		}
		return count;
	}

	@Override
	public int getAnzGazellen()
	{
		int count = 0;
		for(Wildtier tier : tiere)
		{
			if(tier instanceof Gazelle)
				count++;
		}
		return count;
	}

	@Override
	public int getAnzGepard()
	{
		int count = 0;
		for(Wildtier tier : tiere)
		{
			if(tier instanceof Gepard)
				count++;
		}
		return count;
	}

	@Override
	public int getAnzGorilla()
	{
		int count = 0;
		for(Wildtier tier : tiere)
		{
			if(tier instanceof Gorilla)
				count++;
		}
		return count;
	}

	@Override
	public Wildtier getTier(String aId)
	{
		for(Wildtier tier : tiere)
		{
			if(aId.isEmpty())
				throw new NullPointerException("ID darf nicht null sein");
			
			if(tier.getId().equals(aId))
				return tier;
		}
		return null;
	}


	// -------- Ende der Klasse 
}
