package ue231_Zoo;

import java.util.ArrayList;

/****************************************************************************************************
 * 
 * TODO (lösche TODO und füge hier deinen Kommentar ein!)
 *
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class Zoo implements _IZoo
{
	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private ArrayList<Wildtier> zootiere;


	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public Zoo()
	{
		zootiere = new ArrayList<Wildtier>();
	}

	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	public void paintAlleTiere()
	{
		for(Wildtier tier : zootiere)
		{
			tier.paint();
		}
	}
	
	@Override
	public void neuesTierAufnehmen(Wildtier aTier)
	{
		zootiere.add(aTier);
	}

	@Override
	public boolean istTierImZoo(Wildtier aTier)
	{
		return zootiere.contains(aTier);
	}

	@Override
	public void tierEntlassen(Wildtier aTier)
	{
		zootiere.remove(aTier);
	}

	@Override
	public void printTierListe()
	{
		for(Wildtier tier : zootiere)
		{
			System.out.printf("%s \n", tier.toString());
		}
	}

	@Override
	public void printLoewenListe()
	{
		for(Wildtier tier : zootiere)
		{
			if(tier instanceof Loewe)
				System.out.printf("%s \n", tier.toString());
		}
	}

	@Override
	public void alleTiereFuettern()
	{
		for(Wildtier tier : zootiere)
		{
			tier.frissEtwas();
		}
	}

	@Override
	public void alleTiereBewegen()
	{
		for(Wildtier tier : zootiere)
		{
			tier.bewegeDich();
		}
	}

	@Override
	public void alleLoewenBruellen()
	{
		for(Wildtier tier : zootiere)
		{
			if(tier instanceof Loewe)
				tier.gibLaut();
		}
	}

	@Override
	public void alleElefantenWaelzenSich()
	{
		for(Wildtier tier : zootiere)
		{
			if(tier instanceof Elefant)
				((Elefant) tier).waelzeDichImSchlamm();
		}
	}

	@Override
	public void alleGorillasKletternAufDenBaum()
	{
		for(Wildtier tier : zootiere)
		{
			if(tier instanceof Gorilla)
				((Gorilla) tier).klettereAufDenBaum();
		}
	}

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER 
	@Override
	public int getAnzLoewen()
	{
		int count = 0;
		for(Wildtier tier : zootiere)
		{
			if(tier instanceof Loewe)
				count++;
		}
		return count;
	}

	@Override
	public int getAnzElefanten()
	{
		int count = 0;
		for(Wildtier tier : zootiere)
		{
			if(tier instanceof Elefant)
				count++;
		}
		return count;
	}

	@Override
	public int getAnzGazellen()
	{
		int count = 0;
		for(Wildtier tier : zootiere)
		{
			if(tier instanceof Gazelle)
				count++;
		}
		return count;
	}

	@Override
	public int getAnzGepard()
	{
		int count = 0;
		for(Wildtier tier : zootiere)
		{
			if(tier instanceof Gepard)
				count++;
		}
		return count;
	}

	@Override
	public int getAnzGorilla()
	{
		int count = 0;
		for(Wildtier tier : zootiere)
		{
			if(tier instanceof Gorilla)
				count++;
		}
		return count;
	}

	@Override
	public ArrayList<Loewe> getLoewen()
	{
		ArrayList<Loewe> loewen = new ArrayList<Loewe>();
		for(Wildtier tier : zootiere)
		{
			if(tier instanceof Loewe)
				loewen.add((Loewe) tier);
		}
		return loewen;
	}

	@Override
	public ArrayList<Elefant> getElefanten()
	{
		ArrayList<Elefant> elefanten = new ArrayList<Elefant>();
		for(Wildtier tier : zootiere)
		{
			if(tier instanceof Elefant)
				elefanten.add((Elefant) tier);
		}
		return elefanten;
	}

	@Override
	public ArrayList<Gazelle> getGazellen()
	{
		ArrayList<Gazelle> gazellen = new ArrayList<Gazelle>();
		for(Wildtier tier : zootiere)
		{
			if(tier instanceof Gazelle)
				gazellen.add((Gazelle) tier);
		}
		return gazellen;
	}

	@Override
	public ArrayList<Gepard> getGepard()
	{
		ArrayList<Gepard> gepard = new ArrayList<Gepard>();
		for(Wildtier tier : zootiere)
		{
			if(tier instanceof Gepard)
				gepard.add((Gepard) tier);
		}
		return gepard;
	}

	@Override
	public ArrayList<Gorilla> getGorilla()
	{
		ArrayList<Gorilla> gorillas = new ArrayList<Gorilla>();
		for(Wildtier tier : zootiere)
		{
			if(tier instanceof Gorilla)
				gorillas.add((Gorilla) tier);
		}
		return gorillas;
	}

	@Override
	public Wildtier getTier(String aId)
	{
		for(Wildtier tier : zootiere)
		{
			if (aId.isEmpty())
				throw new NullPointerException("ID darf nicht null sein");
			if(tier.getId().equals(aId))
				return tier;
		}
		return null;
	}


	// -------- Ende der Klasse 
}
