package ue231_Zoo;

import java.util.ArrayList;


/****************************************************************************************************
 * 
 * TODO
 *
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public interface _ISavanne
{

	/** --------------------------------------------------------------------------------<br>
	 * Ein neues Tier wird in der Savanne hinzugefügt (Geboren, freigelassen, etc.)
	 * 
	 * @param aTier
	 */
	void neuesTier(Wildtier aTier);

	/** --------------------------------------------------------------------------------<br>
	 * Prüft, ob ein Tier in der Savanne bereits vorhanden ist.
	 * 
	 * @param aTier
	 * @return      true, falls Tier in der Savanne ist
	 */
	boolean istTierInDerSavanne(Wildtier aTier);

	/** --------------------------------------------------------------------------------<br>
	 * Wenn ein Tier stirbt, muss es aus der Savanne entfernt werden.
	 * 
	 * @param aTier
	 */
	void tierStirbt(Wildtier aTier);

	/** --------------------------------------------------------------------------------<br>
	 * Wenn ein Tier die Savanne verlässt, weiterwandert oder gefangen wird, muss es aus der 
	 * Savanne entfernt werden.
	 * 
	 * @param tier
	 */
	void verlaesstSavanne(Wildtier tier);

	/** --------------------------------------------------------------------------------<br>
	 * Liste aller Tiere in der Konsole ausgeben
	 */
	void printTierListe();

	/** --------------------------------------------------------------------------------<br>
	 * Liste aller Löwen in der Konsole ausgeben
	 */
	void printLoewenListe();

	/** --------------------------------------------------------------------------------<br>
	 * Suche den ersten Löwen in der Liste und gib in zurück
	 * 
	 * @return   erster Löwe oder null falls nicht gefunden
	 */
	Loewe getErstenLoewen();

	/** --------------------------------------------------------------------------------<br>
	 * Suche die letzte Gazelle in der Liste und gib sie zurück
	 * 
	 * @return   letzte Gazelle oder null falls nicht gefunden
	 */
	Gazelle getLetzteGazelle();

	/** --------------------------------------------------------------------------------<br>
	 * Suche den ältesten Elefanten in der Liste
	 * 
	 * @return  ältester Elefant oder null falls keiner vorhanden ist
	 */
	Elefant getAeltesterElefant();

	/** --------------------------------------------------------------------------------<br>
	 * Suche das jüngste Tier in der Liste und gib es zurück.
	 * 
	 * @return   jüngstes Wildtier oder null falls keines vorhanden ist
	 */
	Wildtier getJuengstesTier();

	/** --------------------------------------------------------------------------------<br>
	 * Erstelle eine Liste von Tieren einer bestimmten Art.
	 * 
	 * @param aArt  Art welche als Liste zurück gegeben werden soll
	 * @return		Liste der Tiere einer bestimmten Art
	 */
	ArrayList<Wildtier> getTiereEinerArt(String aArt);

	/** --------------------------------------------------------------------------------<br>
	 * Liste aller Gazellen mit einem bestimmten Alter suchen.
	 * 
	 * @param aAlter		Alter der Gazellen welche gesucht sind
	 * @return				Liste der Gazellen mit einem bestimmten Alter
	 */
	ArrayList<Gazelle> gazellenImAlterVon(int aAlter);

	/** --------------------------------------------------------------------------------<br>
	 * Ermittelt die Anzahl der Tiere einer bestimmten Gattung.
	 * 
	 * @return  Anzahl der Tiere einer bestimmten Gattung
	 */
	int getAnzLoewen();

	int getAnzElefanten();

	int getAnzGazellen();

	int getAnzGepard();

	int getAnzGorilla();

	/** --------------------------------------------------------------------------------<br>
	 * Sucht das Wildtier mit einer bestimmten ID.
	 * 
	 * @param aId		ID, des gesuchten Tieres
	 * @return			gesuchtes Wildtier oder null falls nicht gefunden
	 */
	Wildtier getTier(String aId);

}