package ue231_Zoo;
import static org.junit.jupiter.api.Assertions.*;

import java.util.ArrayList;
import java.util.List;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.MethodOrderer;
import org.junit.jupiter.api.Order;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.TestMethodOrder;

/****************************************************************************************************
 * 
 * JUnit Test für Klasse Savanne.
 *
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */


//@TestMethodOrder(MethodOrderer.OrderAnnotation.Alphanumeric.class)
@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
//---------------------------------------------------------------------------------------------------
class _JUT_Savanne
{
//	private static final String errNewNoError = "NEW: Mit diesen Parametern darf keine Exception ausgelöst werden!";
//	private static final String errNewNullPointer  = "NEW: Parameter darf nicht NULL sein (EXCEPTION fehlt): ";;
//	private static final String errNewEmptyStr = "NEW: Parameter darf kein Leerstring sein (EXCEPTION fehlt): ";
//	private static final String errArgIllegal = "Ungültiger Wert! (EXCEPTION fehlt): ";
//	private static final String errArgNoError = "Dieser Wert ist gültig! Hier darf KEINE Exception ausgelöst werden: ";
	private static final String errReturnValue = "Der zurückgegeben Wert ist ungültig! Methode: ";
	private static final String errReturnListe = "Die zurückgegebene Liste ist noch nicht korrekt! Methode: ";

	// -----------------------------------------------------------------
	// Variablen für Testumgebung
	Savanne  testSavanne;

	// >>>>> Beim vorzeigen mit nur einem Tier starten!!!!
	Loewe   leo1, leo2;
	Elefant ele1, ele2;
	Gepard  gep1, gep2;
	Gorilla gor1, gor2;
	Gazelle gaz1;

	// -----------------------------------------------------------------------------------
	@BeforeEach
	void setUp() throws Exception
	{
		testSavanne = new Savanne();

		// >>>>> Beim vorzeigen mit nur einem Tier starten!!!!
		leo1    = new Loewe("LEO01", "Test", 2);
		leo2    = new Loewe("LEO02", "Test", 2);
		gor1    = new Gorilla("GOR01", "EineArt", 3);
		gor2    = new Gorilla("GOR02", "Test", 4);
		ele1    = new Elefant("ELE01", "Test", 1);
		ele2    = new Elefant("ELE02", "EineArt", 6);
		gep1    = new Gepard("GEP01", "Test", 7);
		gep2    = new Gepard("GEP02", "EineArt", 8);
		gaz1    = new Gazelle("GAZ01", "Test", 9);

		testSavanne.neuesTier(leo1);
		testSavanne.neuesTier(leo2);
		testSavanne.neuesTier(ele1);
		testSavanne.neuesTier(ele2);
		testSavanne.neuesTier(gep1);
		testSavanne.neuesTier(gep2);
		testSavanne.neuesTier(gor1);
		testSavanne.neuesTier(gor2);
		testSavanne.neuesTier(gaz1);
	}


	// -----------------------------------------------------------------------------------
	@Test
	@Order(21)
	void testNeuesTier()
	{
		assertTrue(testSavanne.istTierInDerSavanne(gaz1), errReturnValue + "istTierInDerSavanne");

		Gorilla neu = new Gorilla("GORTEST", "Test", 1);
		assertFalse(testSavanne.istTierInDerSavanne(neu), errReturnValue + "istTierInDerSavanne");

		testSavanne.neuesTier(neu);
		assertTrue(testSavanne.istTierInDerSavanne(neu), errReturnValue + "istTierInDerSavanne");
	}


	@Test
	@Order(22)
	void testTierStirbt()
	{
		assertTrue(testSavanne.istTierInDerSavanne(gor2), errReturnValue + "istTierInDerSavanne");
		testSavanne.tierStirbt(gor2);
		assertFalse(testSavanne.istTierInDerSavanne(gor2), errReturnValue + "istTierInDerSavanne");
	}
	@Test
	@Order(23)
	void testTierVerlaesstSavanne()
	{
		assertTrue(testSavanne.istTierInDerSavanne(gor1), errReturnValue + "istTierInDerSavanne");
		testSavanne.verlaesstSavanne(gor1);
		assertFalse(testSavanne.istTierInDerSavanne(gor1), errReturnValue + "istTierInDerSavanne");
	}

	@Test
	void testPrintTierListe()
	{
		testSavanne.printTierListe();
	}

	@Test
	void testPrintLoewenListe()
	{
		testSavanne.printLoewenListe();
	}

	@Test
	void testGetErstenLoewen()
	{
		assertEquals(leo1, testSavanne.getErstenLoewen(), errReturnValue + "getErstenLoewen!");
	}

	@Test
	void testGetLetzteGazelle()
	{
		assertEquals(gaz1, testSavanne.getLetzteGazelle(), errReturnValue + "getLetzteGazelle!");
	}

	@Test
	void testGetAeltesterElefant()
	{
		assertEquals(ele2, testSavanne.getAeltesterElefant(), errReturnValue + "getAeltesterElefant!");
	}

	@Test
	void testGetJuengstesTier()
	{
		assertEquals(ele1, testSavanne.getJuengstesTier(), errReturnValue + "getJuengstesTier!");
	}


	@Test
	void testGetAnzLoewen()
	{
		assertEquals(2,testSavanne.getAnzLoewen(), errReturnValue + "getAnzLoewen");
	}

	@Test
	void testGetAnzElefanten()
	{
		assertEquals(2,testSavanne.getAnzElefanten(), errReturnValue + "getAnzElefanten");
	}

	@Test
	void testGetAnzGazellen()
	{
		assertEquals(1,testSavanne.getAnzGazellen(), errReturnValue + "getAnzGazellen");
	}

	@Test
	void testGetAnzGepard()
	{
		assertEquals(2,testSavanne.getAnzGepard(), errReturnValue + "getAnzGepard");
	}

	@Test
	void testGetAnzGorilla()
	{
		assertEquals(2,testSavanne.getAnzGorilla(), errReturnValue + "getAnzGorilla");
	}

	@Test
	void testGetTiereEinerArt()
	{
		// ----------------------------------------------
		List<Wildtier> v = new ArrayList<>();
		v.add(ele2);    // Beachte die Reihenfolge
		v.add(gep2);
		v.add(gor1);
		assertEquals(v, testSavanne.getTiereEinerArt("EineArt"), errReturnListe +  "getTiereEinerArt");
	}

	@Test
	void testGazellenImAlterVon()
	{
		// ----------------------------------------------
		List<Wildtier> v = new ArrayList<>();
		v.add(gaz1);
		assertEquals(v, testSavanne.gazellenImAlterVon(9), errReturnListe + "gazellenImAlterVon");

		// ----------------------------------------------
		v = new ArrayList<>();
		assertEquals(v, testSavanne.gazellenImAlterVon(12), errReturnListe + "gazellenImAlterVon");
	}

	@Test
	void testGetTier()
	{
		assertEquals(ele1, testSavanne.getTier("ELE01"), errReturnValue + "getTier");
		assertEquals(null, testSavanne.getTier("TEST"), errReturnValue + "getTier");
	}
}
