package ue231_Zoo;
import static org.junit.jupiter.api.Assertions.*;

import java.util.ArrayList;
import java.util.List;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.MethodOrderer;
import org.junit.jupiter.api.Order;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.TestMethodOrder;

/****************************************************************************************************
 * 
 * JUnit Test für Klasse Zoo.
 *
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */


//@TestMethodOrder(MethodOrderer.OrderAnnotation.Alphanumeric.class)
@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
//---------------------------------------------------------------------------------------------------
class _JUT_Zoo
{
//	private static final String errNewNoError = "NEW: Mit diesen Parametern darf keine Exception ausgelöst werden!";
//	private static final String errNewNullPointer  = "NEW: Parameter darf nicht NULL sein (EXCEPTION fehlt): ";;
//	private static final String errNewEmptyStr = "NEW: Parameter darf kein Leerstring sein (EXCEPTION fehlt): ";
//	private static final String errArgIllegal = "Ungültiger Wert! (EXCEPTION fehlt): ";
//	private static final String errArgNoError = "Dieser Wert ist gültig! Hier darf KEINE Exception ausgelöst werden: ";
	private static final String errReturnValue = "Der zurückgegeben Wert ist ungültig! Methode: ";
	private static final String errReturnListe = "Die zurückgegebene Liste ist noch nicht korrekt! Methode: ";

	// -----------------------------------------------------------------
	// Variablen für Testumgebung
	Zoo     testZoo;

	// >>>>> Beim vorzeigen mit nur einem Tier starten!!!!
	Loewe   leo1, leo2;
	Elefant ele1, ele2;
	Gepard  gep1, gep2;
	Gorilla gor1, gor2;
	Gazelle gaz1;

	// -----------------------------------------------------------------------------------
	@BeforeEach
	void setUp() throws Exception
	{
		testZoo = new Zoo();

		// >>>>> Beim vorzeigen mit nur einem Tier starten!!!!
		leo1    = new Loewe("LEO01", "Test", 1);
		leo2    = new Loewe("LEO02", "Test", 2);
		gor1    = new Gorilla("GOR01", "Test", 1);
		gor2    = new Gorilla("GOR02", "Test", 2);
		ele1    = new Elefant("ELE01", "Test", 1);
		ele2    = new Elefant("ELE02", "Test", 2);
		gep1    = new Gepard("GEP01", "Test", 1);
		gep2    = new Gepard("GEP02", "Test", 2);
		gaz1    = new Gazelle("GAZ01", "Test", 1);

		testZoo.neuesTierAufnehmen(leo1);
		testZoo.neuesTierAufnehmen(leo2);
		testZoo.neuesTierAufnehmen(ele1);
		testZoo.neuesTierAufnehmen(ele2);
		testZoo.neuesTierAufnehmen(gep1);
		testZoo.neuesTierAufnehmen(gep2);
		testZoo.neuesTierAufnehmen(gor1);
		testZoo.neuesTierAufnehmen(gor2);
		testZoo.neuesTierAufnehmen(gaz1);
	}


	// -----------------------------------------------------------------------------------
	@Test
	@Order(21)
	void testNeuesTierAufnehmen()
	{
		assertTrue(testZoo.istTierImZoo(gaz1), errReturnValue + "istTierImZoo");

		Gorilla neu = new Gorilla("GORTEST", "Test", 1);
		assertFalse(testZoo.istTierImZoo(neu), errReturnValue + "istTierImZoo");

		testZoo.neuesTierAufnehmen(neu);
		assertTrue(testZoo.istTierImZoo(neu), errReturnValue + "istTierImZoo");
	}


	@Test
	@Order(22)
	void testTierEntlassen()
	{
		assertTrue(testZoo.istTierImZoo(gor2), errReturnValue + "istTierImZoo");
		testZoo.tierEntlassen(gor2);
		assertFalse(testZoo.istTierImZoo(gor2), errReturnValue + "istTierImZoo");
	}

	@Test
	void testPrintTierListe()
	{
		testZoo.printTierListe();
	}

	@Test
	void testPrintLoewenListe()
	{
		testZoo.printLoewenListe();
	}

	@Test
	void testAlleTiereFuettern()
	{
		testZoo.alleTiereFuettern();
	}

	@Test
	void testAlleTiereBewegen()
	{
		testZoo.alleTiereBewegen();
	}

	@Test
	void testAlleLoewenBruellen()
	{
		testZoo.alleLoewenBruellen();
	}

	@Test
	void testAlleElefantenWaelzenSich()
	{
		testZoo.alleElefantenWaelzenSich();
	}

	@Test
	void testAlleGorillasKletternAufDenBaum()
	{
		testZoo.alleGorillasKletternAufDenBaum();
	}

	@Test
	void testGetAnzLoewen()
	{
		assertEquals(2,testZoo.getAnzLoewen(), errReturnValue + "getAnzLoewen");
	}

	@Test
	void testGetAnzElefanten()
	{
		assertEquals(2,testZoo.getAnzElefanten(), errReturnValue + "getAnzElefanten");
	}

	@Test
	void testGetAnzGazellen()
	{
		assertEquals(1,testZoo.getAnzGazellen(), errReturnValue + "getAnzGazellen");
	}

	@Test
	void testGetAnzGepard()
	{
		assertEquals(2,testZoo.getAnzGepard(), errReturnValue + "getAnzGepard");
	}

	@Test
	void testGetAnzGorilla()
	{
		assertEquals(2,testZoo.getAnzGorilla(), errReturnValue + "getAnzGorilla");
	}

	@Test
	void testGetLoewen()
	{
		// ----------------------------------------------
		List<Wildtier> v = new ArrayList<>();
		v.add(leo1);
		v.add(leo2);
		assertEquals(v, testZoo.getLoewen(), errReturnListe + "getLoewen");
	}

	@Test
	void testGetElefanten()
	{
		// ----------------------------------------------
		List<Wildtier> v = new ArrayList<>();
		v.add(ele1);
		v.add(ele2);
		assertEquals(v, testZoo.getElefanten(), errReturnListe + "getElefanten");
	}

	@Test
	void testGetGazellen()
	{
		// ----------------------------------------------
		List<Wildtier> v = new ArrayList<>();
		v.add(gaz1);
		assertEquals(v, testZoo.getGazellen(), errReturnListe + "getGazellen");
	}

	@Test
	void testGetGepard()
	{
		// ----------------------------------------------
		List<Wildtier> v = new ArrayList<>();
		v.add(gep1);
		v.add(gep2);
		assertEquals(v, testZoo.getGepard(), errReturnListe + "getGepard");
	}

	@Test
	void testGetGorilla()
	{
		// ----------------------------------------------
		List<Wildtier> v = new ArrayList<>();
		v.add(gor1);
		v.add(gor2);
		assertEquals(v, testZoo.getGorilla(), errReturnListe + "getGorilla");
	}

	@Test
	void testGetTier()
	{
		assertEquals(ele1, testZoo.getTier("ELE01"), errReturnValue + "getTier");
		assertEquals(null, testZoo.getTier("TEST"), errReturnValue + "getTier");
	}
}
