package ue231_Zoo;

/****************************************************************************************************
 * 
 * Verwaltung der Tiere einer Savanne.
 *
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */


//---------------------------------------------------------------------------------------------------
public class _Main_SavanneSuS
{

	// -------------------------------------------------------------------------------------
	public static void main(String[] args)
	{
		Zoo zoo = new Zoo();
		
		Savanne savanne = new Savanne();
		savanne.neuesTier(new Elefant("ELE-1001", "Indischer Elefant", 12));
		savanne.neuesTier(new Gazelle("GAZ-2001", "Streifengazelle", 2));
		savanne.neuesTier(new Gorilla("GOR-4001", "Orang Utan", 8));
		savanne.neuesTier(new Gazelle("GAZ-2003", "Streifengazelle", 4));
		savanne.neuesTier(new Gepard("GEP-3001", "Gepard", 3));
		savanne.neuesTier(new Elefant("ELE-1002", "Afrikanischer Elefant", 25));
		savanne.neuesTier(new Gorilla("GOR-4002", "Berggorilla", 14));
		savanne.neuesTier(new Loewe("LOE-5001", "Senegal Löwe", 5));
		savanne.neuesTier(new Loewe("LOE-5002", "Senegal Löwe", 5));
		savanne.neuesTier(new Gazelle("GAZ-2002", "Streifengazelle", 4));


		
		System.out.printf("\n-------------------------------------------------------------\n");
		System.out.printf("> Liste aller Tiere\n");
		savanne.printTierListe();

		
		System.out.printf("\n-------------------------------------------------------------\n");
		System.out.printf("> ANZAHL der Löwen, Geparden, Elefanten, Gazellen, Gotillas \n");
		System.out.printf("Anzah Löwen: 		%s \n", savanne.getAnzLoewen());
		System.out.printf("Anzah Geparden: 	%s \n", savanne.getAnzGepard());
		System.out.printf("Anzah Elefanten: 	%s \n", savanne.getAnzElefanten());
		System.out.printf("Anzah Gazellen: 	%s \n", savanne.getAnzGazellen());
		System.out.printf("Anzah Gorillas: 	%s \n", savanne.getAnzGorilla());

		

		System.out.printf("\n-------------------------------------------------------------\n");
		System.out.printf("> FINDE ALLE GAZELLEN IM ALTER von 4 Jahren \n");
		for(Gazelle gazelle : savanne.gazellenImAlterVon(4))
		{
			System.out.printf("%s \n", gazelle.toString());
		}

		
		
		System.out.printf("\n-------------------------------------------------------------\n");
		System.out.printf("> Die 3 JÜNGSTEN TIERE KOMMEN in den ZOO \n");
		for(int i = 0; i < 3 ; i++)
		{
			System.out.printf("%s \n", savanne.getJuengstesTier().toString());
			zoo.neuesTierAufnehmen(savanne.getJuengstesTier());
			savanne.verlaesstSavanne(savanne.getJuengstesTier());
		}

		
		System.out.printf("\n-------------------------------------------------------------\n");
		System.out.printf("> DER ERSTE LÖWE FRISST die LETZTE Gazelle \n");
		System.out.printf("%s \n", savanne.getLetzteGazelle().toString());
		savanne.tierStirbt(savanne.getLetzteGazelle());
		System.out.printf("%s \n", savanne.getErstenLoewen().toString());

		
		System.out.printf("\n-------------------------------------------------------------\n");
		System.out.printf("> DER ÄLTESTE EEFANT kommt in den ZOO \n");
		System.out.printf("%s \n", savanne.getAeltesterElefant());
		zoo.neuesTierAufnehmen(savanne.getAeltesterElefant());
		savanne.verlaesstSavanne(savanne.getAeltesterElefant());
		
		System.out.printf("\n-------------------------------------------------------------\n");
		System.out.printf("> ALLE SENEGAL LÖWEN kommen in den ZOO \n");
		for(Wildtier tier : savanne.getTiereEinerArt("Senegal Löwe"))
		{
			System.out.printf("%s \n", tier.toString());
			savanne.verlaesstSavanne(tier);
			zoo.neuesTierAufnehmen(tier);
		}

		
		System.out.printf("\n-------------------------------------------------------------\n");
		System.out.printf("> DIE GAZELLE mit der ID GAZ-2001 wird aus dem Zoo in die Savanne freigelassen \n");
		System.out.printf("%s \n", zoo.getTier("GAZ-2001").toString());
		savanne.neuesTier(zoo.getTier("GAZ-2001"));
		zoo.tierEntlassen(zoo.getTier("GAZ-2001"));
		
		System.out.printf("\n-------------------------------------------------------------\n");
		System.out.printf("> DER Gorilla mit der ID GOR-4002 stirbt \n");
		System.out.printf("%s \n", savanne.getTier("GOR-4002"));
		savanne.tierStirbt(savanne.getTier("GOR-4002"));
		
		System.out.printf("\n-------------------------------------------------------------\n");
		System.out.printf("> Liste aller Tiere in der Savanne\n");
		savanne.printTierListe();
		

		System.out.printf("\n-------------------------------------------------------------\n");
		System.out.printf("> Liste aller Tiere im Zoo\n");
		zoo.printTierListe();
		

	}
}
