package ue241_HerrDerRinge;

/****************************************************************************************************
 * 
 * @author Prof. Gaisberger
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public interface _IWesen
{

	// -------------------------------------------------------------------------
	// Diese Methoden sind abstrakt und müssen von der abgeleiteten Klasse
	// implementiert werden
	//
	/** --------------------------------------------------------------------------------<br>
	 * Da wir nicht wissen welches Wesen, können wir nicht sagen wie es kämpft, schläft
	 * oder läuft. Wir wissen jedoch dass ein Wesen kämpfen, schlafen und laufen kann!
	 * Wie sich das Wesen diese Fähigkeitenausführt, muss in der abgeleiteten Klasse 
	 * festgelegt werden.
	 */
	void kaempfen();

	void schlafen();

	void laufen();

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER
	/** --------------------------------------------------------------------------------<br>
	 *
	 * @return	Name des Wesen
	 */
	String getName();

	/** --------------------------------------------------------------------------------<br>
	 * @return	Stärke des Wesen
	 */
	int getStaerke();

	/**
	 * Setzt die Stärke des Wesen auf einen neuen Wert
	 *
	 * @param aStaerke
	 */
	void setStaerke(int aStaerke);

	/** --------------------------------------------------------------------------------<br>
	 * @return	Waffe des Wesen
	 */
	String getWaffe();

	/** --------------------------------------------------------------------------------<br>
	 * Setzt eine neue Waffe für das Wesen
	 *
	 * @param aWaffe		Nicht null und nicht leer
	 */
	void setWaffe(String aWaffe);

	/** --------------------------------------------------------------------------------<br>
	 * @return	Freund des Wesen
	 */
	Wesen getFreundVon();

	/**
	 * Gibt dem Wesen einen neuen Freund
	 *
	 * @param aFreundVon	darf auch null sein
	 */
	void setFreundVon(Wesen aFreundVon);

	/** --------------------------------------------------------------------------------<br>
	 * Setzt ein neues Bild für das Wesen.
	 * 
	 * @param aPicture
	 */
	void setPicture(String aPicture);

	// -----------------------------------------------------------------------------------
	// Methoden 
	/** --------------------------------------------------------------------------------<br>
	 * Zeichnet das Wesen im Grafikfenster
	 * 
	 */
	void paint();

	/** --------------------------------------------------------------------------------<br>
	 * Zeichnet das Wesen im Grafikfenster an eine bestimmte Position
	 * 
	 * @param	x, y	Position an die das Wesen gezeichnet werden soll
	 */
	void paint(int aX, int aY);

	/** --------------------------------------------------------------------------------<br>
	 * Bewegt das Spielobjekt an eine bestimmte Position
	 * 
	 * @param	aX, aY	Position an die das Wesen bewegt werden soll
	 * @param	aDelay  ms Zeit wielange die Bewegung dauern soll  
	 */
	void moveTo(int aX, int aY, int aDelay);

	/** --------------------------------------------------------------------------------<br>
	 * Position des Wesens.
	 *  
	 * @return 	x-Position
	 */
	int getX();

	/** --------------------------------------------------------------------------------<br>
	 * Setzt die Position des Wesens.
	 *  
	 * @param aX 	x-Position welche für das Wesen übernommen werden soll
	 */
	void setX(int aX);

	/** --------------------------------------------------------------------------------<br>
	 * Position des Wesens.
	 *  
	 * @return 	y-Position
	 */
	int getY();

	/** --------------------------------------------------------------------------------<br>
	 * Setzt die Position des Wesens.
	 *  
	 * @param aX 	y-Position welche für das Wesen übernommen werden soll
	 */
	void setY(int aY);

	// ---------------------------------------------------------------------------------
	String toString();

}