package ue322_Steuerung;

/****************************************************************************************************
 * 
 * TODO Steuerbares Auto
 *
 * @author Sven Marceta
 * @version 1.0
 *
 ****************************************************************************************************
 */

//---------------------------------------------------------------------------------------------------
public class AutoSteuerbar extends Fahrzeug implements _ISteuerung
{

	// -------------------------------------------------------------------------------------
	// Instanzvariablen/Klassenvariablen
	private double geschwindigkeit;
	private double richtung;

	// -------------------------------------------------------------------------------------
	// KONSTRUKTOR oder main
	public AutoSteuerbar(String aBezeichnung, double aMaxGeschwindigkeit, double aMaxBeschleunigung,
			double aMaxVerzoegerung)
	{
		super(aBezeichnung, aMaxGeschwindigkeit, aMaxBeschleunigung, aMaxVerzoegerung);
	}

	// -------------------------------------------------------------------------------------
	// INSTANZMETHODEN
	@Override
	public double nachLinks(double aGrad)
	{
		richtung = richtung - aGrad;
		if(richtung < -360)
			richtung += 360;
		if(richtung > 360)
			richtung -= 360;
		return richtung;
	}

	@Override
	public double nachRechts(double aGrad)
	{
		richtung = richtung + aGrad;
		if(richtung < -360)
			richtung += 360;
		if(richtung > 360)
			richtung -= 360;
		return richtung;
	}

	@Override
	public double beschleunigen(double aMetProSek2, double aSek)
	{
		//Überprüfung
		if(aMetProSek2 <= 0)
			throw new IllegalArgumentException("MetProSek muss größer als 0 sein");
		else if(aMetProSek2 > getMaxBeschleunigung())
			aMetProSek2 = getMaxBeschleunigung();
		if(aSek < 0)
			throw new IllegalArgumentException("aSek muss größer als 0 sein");
		
		geschwindigkeit = (geschwindigkeit/3.6) + aMetProSek2 * aSek;
		geschwindigkeit = geschwindigkeit * 3.6;
		if(geschwindigkeit > getMaxGeschwindigkeit())
			geschwindigkeit = getMaxGeschwindigkeit();
		return geschwindigkeit;
	}

	@Override
	public double beschleunigen(double aSek)
	{
		//Überprüfung
		if(aSek < 0)
			throw new IllegalArgumentException("aSek muss größer als 0 sein");
		
		geschwindigkeit = (geschwindigkeit/3.6) + getMaxBeschleunigung() * aSek;
		geschwindigkeit = geschwindigkeit * 3.6;//auf km/h umrechnen
		
		if(geschwindigkeit > getMaxGeschwindigkeit())
			geschwindigkeit = getMaxGeschwindigkeit();
		
		return geschwindigkeit;
	}

	@Override
	public double bremsen(double aMetProSek2, double aSek)
	{
		//Überprüfung
		if(aMetProSek2 <= 0)
			throw new IllegalArgumentException("MetProSek muss größer als 0 sein");
		else if(aMetProSek2 > getMaxVerzoegerung())
			aMetProSek2 = getMaxVerzoegerung();
		if(aSek <= 0)
			throw new IllegalArgumentException("Sek muss größer als 0 sein");
		
		
		geschwindigkeit = (geschwindigkeit/3.6) - aMetProSek2 * aSek;
		geschwindigkeit = geschwindigkeit * 3.6;
		
		if(geschwindigkeit < 0)
			geschwindigkeit = 0;
		
		return geschwindigkeit;
	}

	@Override
	public double bremsen(double aSek)
	{
		if(aSek <= 0)
			throw new IllegalArgumentException("aSek muss größer als 0 sein");
		
		geschwindigkeit = (geschwindigkeit/3.6) - getMaxVerzoegerung() * aSek;
		geschwindigkeit = geschwindigkeit * 3.6;
		
		if(geschwindigkeit < 0)
			geschwindigkeit = 0;
		
		return geschwindigkeit;
	}

	// -------------------------------------------------------------------------------------
	// GETTER / SETTER 
	@Override
	public double getRichtung()
	{
		return richtung;
	}

	@Override
	public double getGeschwindigkeit()
	{
		return geschwindigkeit;
	}

	// -------------------------------------------------------------------------------------
	// TOSTRING
	@Override
	public String toString()
	{
		return String.format("AutoSteuerbar [geschwindigkeit=%s, richtung=%s, toString()=%s]", geschwindigkeit,
				richtung, super.toString());
	}


	// -------- Ende der Klasse 
}
