package ue322_Steuerung;

import static org.junit.jupiter.api.Assertions.*;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;


/****************************************************************************************************
 * 
 * JUT für Autosteuerung
 *
 * @author Sven Marceta
 * @version 1.0
 *
 ****************************************************************************************************
 */


//---------------------------------------------------------------------------------------------------
class JUT_AutoSteuerung
{

	/** TODO Beschreibe die Funktion der Methode, alle Parameter und den Rückgabewert
	 *
	 * @throws java.lang.Exception
	 */
	@BeforeEach
	void setUp() throws Exception
	{
	}
	// -------------------------------------------------------------------------------------
	// INSTANZVARIABLEN

	@Test
	void testAutoSteuerbar()
	{
		AutoSteuerbar auto = new AutoSteuerbar("Auto", 150, 9.8, 4.7);
		
		assertEquals("Auto", auto.getMarke());
		
		assertEquals(150, auto.getMaxGeschwindigkeit());
		assertEquals(9.8, auto.getMaxBeschleunigung());
		assertEquals(4.7, auto.getMaxVerzoegerung());

		assertEquals(0, auto.getGeschwindigkeit());
		assertEquals(0, auto.getRichtung());
		
		auto.setMaxGeschwindigkeit(200);
		assertEquals(200, auto.getMaxGeschwindigkeit());

		auto.setMaxBeschleunigung(1.2);
		assertEquals(1.2, auto.getMaxBeschleunigung());

		auto.setMaxVerzoegerung(0.8);
		assertEquals(0.8, auto.getMaxVerzoegerung());

		_ISteuerung strg = auto;
		assertEquals(0, strg.getGeschwindigkeit());
		assertEquals(0, strg.getRichtung());
	}

	@Test
	void testBeschleunigen()
	{
		AutoSteuerbar auto = new AutoSteuerbar("Auto", 150, 5, 2);

		auto.setMaxBeschleunigung(5);  // 5m/s

		assertEquals(150., auto.beschleunigen(10));
		
		assertEquals(150., auto.beschleunigen(2, 5));

		assertEquals(150., auto.beschleunigen(1000));
		assertEquals(150., auto.beschleunigen(1, 10000));
		
		assertEquals(141., auto.bremsen(0.5, 5));
		
		//Nullpointer testen
		assertThrows(IllegalArgumentException.class, () -> {auto.beschleunigen(-2, 5);},
				"MetProSek muss größer als 0 sein");
		
		assertThrows(IllegalArgumentException.class, () -> {auto.beschleunigen(2, -5);},
				"Sek muss größer als 0 sein");
		
		
		// Das darf eigentlich nicht möglich sein
		//assertEquals(141, auto.beschleunigen(-2, 5));
		// Das darf eigentlich nicht möglich sein
		//assertEquals(141, auto.beschleunigen(2, -5));
	}

	@Test
	void testBremsen()
	{
		AutoSteuerbar auto = new AutoSteuerbar("Auto", 150, 5, 2);

		auto.setMaxVerzoegerung(5);  // 5m/s

		assertEquals(0., auto.bremsen(10));

		
		assertEquals(150., auto.beschleunigen(10));
		assertEquals(114., auto.bremsen(2, 5));

		assertEquals(0., auto.bremsen(2, 50));
		
		
		assertEquals(150., auto.beschleunigen(10));
		assertEquals(141, auto.bremsen(0.5, 5));
		assertEquals(0, auto.bremsen(15));
		
		auto.beschleunigen(2,0.75);
		
		//Nullpointer testen
		assertThrows(IllegalArgumentException.class, () -> {auto.bremsen(-2, 5);},
				"MetProSek muss größer als 0 sein");
		
		assertThrows(IllegalArgumentException.class, () -> {auto.bremsen(2, -5);},
				"Sek muss größer als 0 sein");
		
		
		// Das darf eigentlich nicht möglich sein
		//assertEquals(5.4, auto.bremsen(-2, 5));

		// Das darf eigentlich nicht möglich sein
		//assertEquals(5.4, auto.bremsen(2, -5));
	}

	
	@Test
	void testLenkung()
	{
		AutoSteuerbar auto = new AutoSteuerbar("Auto", 150, 5, 2);
		
		assertEquals(12, auto.nachRechts(12));
		assertEquals(17, auto.nachRechts(5));
		
		assertEquals(-3, auto.nachLinks(20));
		
		assertEquals(-3, auto.nachLinks(360));
		
		assertEquals(357, auto.nachRechts(720));
		
	}



	// -------- Ende der Klasse 
}
